'-------------------------------------------------------------------------------------
'myMsgbox by Charles Dietz  02-14-05
'substitute for MS Windows Msgbox
'allow sound to be optional and desktop location to be specified
'also allow option of modal or modeless
'------------------------------------------------------------------------------------- 
      
FUNCTION myMsgBox(msg AS STRING, OPT BYVAL nStyle AS LONG, BYVAL ti AS STRING, _
                  BYVAL sound AS LONG, BYVAL x0 AS LONG, BYVAL y0 AS LONG) AS LONG
   'nStyle = %MB_OK               for 1 button:  Ok
   '       = %MB_YESNO            for 2 buttons: Ok, Cancel
   '       = %MB_OKCANCEL         for 2 buttons: Yes, No
   '       = %MB_YESNOCANCEL      for 3 buttons: Yes, No, Cancel
   '       = %MB_ICONERROR        for error icon (stop sign)
   '       = %MB_ICONINFORMATION  for information icon
   '       = %MB_ICONQUESTION     for question icon
   '       = %MB_ICONWARNING      for warning icon
   '       = negative value       for modal dialog
   'ti = title and sound = 1 for beep
   ' x0, y0 = location relative to parent dialog
   ' x0, y0 = location absolute when > 1000000
   'Returns %IDOK, %IDYES, %IDNO, or %IDCANCEL
   'Requires "WIN32API.INC"
   'Load this include file before myMsgbox is used
   '----------------------------------------------------------------------------
   LOCAL wi, ht, x, y, w, h, i, m, n, k, myMsgboxReturn, nModal AS LONG
   LOCAL hMsgBox, hParent, hdc, hFont, hOrigFont, hIcon, nnStyle AS LONG
   LOCAL s AS STRING , ss AS STRING
   LOCAL rc AS RECT, t AS SIZEL

   IF nStyle < 0 THEN nModal = 1: nStyle = ABS(nStyle)
   hParent = GetActiveWindow
   nnStyle = %WS_CAPTION OR %WS_SYSMENU OR %DS_MODALFRAME
   DIALOG NEW pixels, hParent, ti, , , 200, 100, nnStyle TO hMsgBox
   DIALOG SET COLOR hMsgBox, -1, %WHITE      
                                           
   'size the message box and add controls  -------------------------------------
   hdc = GetDc(hMsgbox)
   hFont = SendMessage(hMsgbox, %WM_GETFONT, 0, 0)
   hOrigFont = SelectObject(hDC, hFont)                 
   n = parsecount(msg, $crlf)
   redim arr(1 to n) as string
   parse msg, arr(), $crlf                                            
   for i = 1 to n
      s = arr(i)
      GetTextExtentPoint32 hdc, BYVAL STRPTR(s), LEN(s), t
      m = MAX(m, t.cx)
   next i
   GetTextExtentPoint32 hdc, BYVAL STRPTR(ti), LEN(ti), t
   m = max(m, t.cx)
   SelectObject hDC, hOrigFont              
   ReleaseDC hMsgBox, hdc
   IF nStyle > 6 THEN k = 50 ELSE k = 10
   CONTROL ADD LABEL, hMsgBox, 9990, msg, k, 5, m, 15*n
   CONTROL SET COLOR hMsgBox, 9990, RGB(0, 0, 0), %WHITE  '%LTGRAY
   wi = MAX(220, m + k + 25): ht = max(120, n * t.cy + 100)
   '----------------------------------------------------------------------------
        
   m = nStyle MOD 16: n = ht - 70
   IF m = %MB_YESNOCANCEL THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Yes", 10, n, 60, 30, %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&No", 75, n, 60, 30
      CONTROL ADD BUTTON, hMsgBox, 9993, "Cancel", 140, n, 60, 30
      CONTROL SET FOCUS hMsgbox, 9991
   ELSEIF m = %MB_YESNO THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Yes", 10, n, 60, 30  ', %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9992, "&No", 75, n, 60, 30
   ELSEIF m = %MB_OKCANCEL THEN
      CONTROL ADD BUTTON, hMsgBox, 9991, "&Ok", 10, n, 60, 30, %BS_DEFAULT
      CONTROL ADD BUTTON, hMsgBox, 9993, "&Cancel", 75, n, 60, 30
   ELSE
      CONTROL ADD BUTTON, hMsgBox, 9994, "&Ok", 30, n, 80, 30, %BS_DEFAULT
   END IF
   'default location of msgbox -------------------------------------------------
   IF hParent THEN
      GetWindowRect hParent, rc: x = rc.nLeft: y = rc.nTop
      w = rc.nRight - rc.nLeft: h = rc.nBottom - rc.nTop
   ELSE
      DESKTOP GET CLIENT TO w, h
   END IF
   if x0 > 1000000 or y0 > 1000000 then
      x0 = max(x0 - 1000000, 0): y0 = max(y0 - 1000000, 0)
   elseIF x0 OR y0 THEN                                                   
      x = x + MAX(x0, 0): y = y + MAX(y0, 0)
   ELSE
      x = x + (w - wi)/2: y = y + (h - ht)/2
   END IF
   MoveWindow hMsgbox, x, y, wi, ht, %TRUE
   'add icon to msgbox ---------------------------------------------------------
   CONTROL ADD LABEL, hMsgBox, 9995, "", 10, 5, 0, 0, %SS_ICON
   CONTROL SET COLOR hMsgBox, 9995, RGB(0, 0, 0), %WHITE  '%LTGRAY
   k = %MB_OK: m = nStyle - m
   IF m = %MB_ICONERROR THEN                           
      n = 103: k = %MB_ICONHAND
   ELSEIF m = %MB_ICONQUESTION THEN
      n = 102: k = %MB_ICONQUESTION
   ELSEIF m = %MB_ICONWARNING THEN
      n = 101: k = %MB_ICONEXCLAMATION
   ELSEIF m = %MB_ICONINFORMATION THEN
      n = 104: k = %MB_ICONASTERISK
   END IF
   hIcon = LoadImage(BYVAL 0, BYVAL n, %IMAGE_ICON, 32, 32, 0)
   SendDlgItemMessage hMsgBox, 9995, %STM_SETIMAGE, %IMAGE_ICON, hIcon
   '----------------------------------------------------------------------------
   IF sound THEN MessageBeep k
   IF nModal THEN
      DIALOG SHOW MODAL hMsgbox, CALL myMsgBoxProc TO myMsgboxReturn
   ELSE
      DIALOG SHOW MODELESS hMsgbox, CALL myMsgBoxProc TO myMsgboxReturn
   END IF
   FUNCTION = myMsgBoxReturn
END FUNCTION

CALLBACK FUNCTION myMsgBoxProc()
   LOCAL ret AS LONG
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG
         CONTROL SEND CBHNDL, 9991, %BM_SETSTYLE, %BS_DEFPUSHBUTTON, %TRUE
         SetWindowPos CBHNDL, %HWND_TOPMOST, 0,0,0,0, %SWP_NOMOVE OR %SWP_NOSIZE
      CASE %WM_COMMAND
         SELECT CASE CBCTL
         CASE 9991, %IDOK
            ret = %IDYES
         CASE 9992, %IDCANCEL
            ret = %IDNO
         CASE 9993
            ret = %IDCANCEL
         CASE 9994
            ret = %IDOK
         CASE ELSE
            EXIT FUNCTION
         END SELECT
         DIALOG END CBHNDL, ret
   END SELECT
END FUNCTION
