#COMPILE EXE                                                                                                 
#DIM ALL                                                                        
'#debug display on                                                    
#INCLUDE "wIN32api.inc"                                    
#INCLUDE "appHelp.inc"                
#include ".\myMsgbox.inc"                                            
'#include "debug.inc"                         
                                                                                  
#RESOURCE "myReminders.pbr"                         

'#resource ICON, Alight, "myReminders.ico"
'#resource icon, leftArrow, "leftArrow.ico"                 
'#resource icon, rightArrow, "rightArrow.ico"                    
'#resource bitmap, today, "today.bmp"                            
'#RESOURCE VERSIONINFO                                                                                                              
'#RESOURCE FILEVERSION 2, 0, 0, 0                   
'#RESOURCE PRODUCTVERSION 2, 0, 0, 0
'#RESOURCE STRINGINFO "0409", "04B0"
'#RESOURCE VERSION$ "Comments",         "Help remembering important personal dates"
'#RESOURCE VERSION$ "CompanyName",      "CGD Software"
'#RESOURCE VERSION$ "FileDescription",  "Application (03-11-2023"
'#RESOURCE VERSION$ "FileVersion",      "Version 2.00 (03-11-2023)"
'#RESOURCE VERSION$ "InternalName",     "myReminders"                        
'#RESOURCE VERSION$ "LegalCopyright",   "No Copyright 2016"
'#RESOURCE VERSION$ "LegalTrademarks",  "None"
'#RESOURCE VERSION$ "OriginalFilename", "myReminders"
'#RESOURCE VERSION$ "ProductName",      "myReminders"
'#RESOURCE VERSION$ "ProductVersion",   "Version 2.0.0"
    
'ver 3.01, 4-2-23
'- keep one month of reminders archived 
'- list archives and print them
'ver 3.02, 4-3-23
'- double click reminder also acts like New to create a multiple
'- dispense with time in new reminder insertion point
'- Next/Prev to work from any calendar date, not just a reminder date
'ver 3.03, 4-24-23
'- click on left part of status bar for complete path to dataFile 
'- dblclk on left part of status bar to change dataFile location
'- corrected time to hold year for birthday and anniversary
'ver 3.04, 4-28-23
'- use settings button instead of clicking on statusbar
'- store iniFile and helpFile in ProgramData

$version = "3.03"                                         

%ID_Event         = 201
%ID_Event0        = 202             
%ID_Descr         = 203
%ID_Descr0        = 204                                    
%ID_Date          = 205            
%ID_Date0         = 206
%ID_Time0         = 207
%ID_Time          = 208
%ID_Notify        = 209
%ID_Notify0       = 210
%ID_Weekday       = 211
%ID_DaysBefore    = 212
%ID_Period        = 213
%ID_Period0       = 214

%ID_Freq          = 220
%ID_OneTime       = 221
%ID_Annual        = 222
%ID_MonthlyPer    = 223
%ID_WeeklyPer     = 224
%ID_WeekdayMos    = 225

%ID_New           = 230                          
%ID_Add           = 231
%ID_Del           = 232
%ID_Cancel        = 233                                       
%ID_Next          = 241
%ID_Prev          = 242
%ID_List          = 243
%ID_Show          = 244 
%ID_Help          = 245
%ID_Settings      = 246
%ID_Status        = 250 
%IDC_LeftArrow    = 251
%IDC_rightArrow   = 252
                                                                
%ID_ListReminders = 300                          
%ID_Header        = 301
%ID_Delete        = 302                                  
%ID_Back          = 303
%ID_Print         = 304
%ID_Close         = 305                                    
%ID_Current       = 306
%ID_Archive       = 307
            
%ID_ShowLoc       = 321
%ID_SetLoc        = 322
%ID_Reset         = 323
                                                                  
TYPE reminderType
   nEvent AS BYTE               'event (birthday, anniversary, appointment, meeting, other)
   descr AS STRING *48          'description of event (Dr Smith, orthopedic)
   date AS LONG                 'next date for event (20231013 for 10-13-2023)
   time AS INTEGER              'military time or year of birthday/anniversary
   adv AS BYTE                  'notify days in advance (255 max)
   period AS BYTE               'number of weeks or months per period                     
   freq AS BYTE                 'oneTime = 1, annual = 2, monthly period = 3
                                'weekly period = 4, weekday period = 5
END TYPE

global bug as long
global hDlg, hList, hSettings, numReminders, reminderNo, reminderHiLite, hRemindForm as long
global thisMo, thisYr, today, theYr, theMo, theDay, selMo, selDay, selYr, formChanged as long
global xMouse, yMouse, xMouse2, yMouse2, fileChanged, nArrow, initialized, nextPrev, leftBtnDn as long  
global listMode, noPaint, formDone, dblClk, editing, numArchives, archiveMode, savReminderNo as long
global dataFile, helpFile, iniFile, progDataFolder, dataFolder, myDataFolder as string 
global fontType, daysInWeek, weekDay as string
global multReminds() as long                
global nEvents(), weekDays() as string
GLOBAL myReminders() AS reminderType
GLOBAL remindersArch() AS reminderType

FUNCTION PBMAIN()
   LOCAL n, nStyle, hInst, hIcon, hMutex AS LONG                                       
   local ti, s as string
   DIM myReminders(1 to 200)        
   dim multReminds(1 to 200)                                                            
   dim remindersArch(1 to 200)
   dim weekDays(6)
   dim nEvents(1 to 5)
   nEvents(1) = "birthday"                                       
   nEvents(2) = "anniversary"                                
   nEvents(3) = "reminder"
   nEvents(4) = "appointment"                               
   nEvents(5) = "meeting"
   daysInWeek = "Sun Mon Tue Wed Thu Fri Sat"
   ti = "myReminders - ver " + $version
   IF alreadyRunning(hMutex, "myReminders") then
      MSGBOX "myReminders is already loaded", %MB_iconerror, " "
      EXIT FUNCTION
   END IF
   DIALOG NEW 0, ti, 80, 20, 300, 340, %WS_SYSMENU or %WS_MINIMIZEBOX TO hDlg
   DIALOG SET COLOR hDlg, -1, %WHITE
   hInst = GetModuleHandle(BYVAL %NULL)
   hIcon = LoadImage(hInst, "light", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
   DIALOG SEND hDlg, %WM_SETICON, 0, hIcon
   control add imagex, hDlg, %IDC_LeftArrow, "leftArrow", 1, 5, 15, 15, %SS_icon or %SS_notify
   control add imagex, hDlg, %IDC_rightArrow, "rightArrow", 280, 5, 15, 15, %SS_icon or %SS_notify 
   n = 145    
   nStyle = %WS_TABSTOP OR %CBS_DROPDOWN OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
   CONTROL ADD LABEL, hDlg, %ID_Event0, "Event", 5, n + 7, 22, 10, %SS_RIGHT
   CONTROL SET COLOR hDlg, %ID_Event0, %Black, %White
   CONTROL ADD COMBOBOX, hDlg, %ID_Event, nEvents(), 30, n + 5, 70, 60, nStyle
   CONTROL ADD LABEL, hDlg, %ID_Descr0, "Descr", 5, n + 27, 22, 10, %SS_RIGHT              
   CONTROL SET COLOR hDlg, %ID_Descr0, %Black, %White
   CONTROL ADD TEXTBOX, hDlg, %ID_Descr, "", 30, n + 25, 155, 13
   CONTROL ADD LABEL, hDlg, %ID_Date0, "Date", 2, n + 47, 25, 13, %SS_RIGHT
   CONTROL SET COLOR hDlg, %ID_Date0, %Black, %White
   CONTROL ADD TEXTBOX, hDlg, %ID_Date, "", 30, n + 45, 42, 13                        
   CONTROL ADD TEXTBOX, hDlg, %ID_Time, "", 150, n + 45, 35, 13
   CONTROL ADD LABEL, hDlg, %ID_Time0, "Time", 106, n + 47, 42, 10, %SS_RIGHT                
   CONTROL SET COLOR hDlg, %ID_Time0, %Black, %White
   CONTROL ADD TEXTBOX, hDlg, %ID_Notify, "", 30, n + 65, 18, 13                      
   CONTROL ADD LABEL, hDlg, %ID_Notify0, "Notify", 5, n + 67, 22, 13, %SS_RIGHT
   CONTROL SET COLOR hDlg, %ID_Notify0, %Black, %White
   CONTROL ADD LABEL, hDlg, %ID_DaysBefore, "days before", 50, n + 67, 60, 13, %SS_LEFT
   CONTROL SET COLOR hDlg, %ID_DaysBefore, %Black, %White
   CONTROL ADD LABEL, hDlg, %ID_Weekday, "", 75, n + 47, 50, 13, %SS_left
   CONTROL SET COLOR hDlg, %ID_Weekday, %Black, %White                             
   CONTROL ADD TEXTBOX, hDlg, %ID_Period, "", 165, n + 65, 20, 13                     
   CONTROL ADD LABEL, hDlg, %ID_Period0, "", 105, n + 66, 57, 22, %SS_RIGHT
   CONTROL SET COLOR hDlg, %ID_Period0, %Black, %White
   CONTROL ADD OPTION, hDlg, %ID_OneTime, "One time", 10, n + 100, 40, 10                     
   CONTROL SET COLOR hDlg, %ID_OneTime, %Black, %White
   CONTROL ADD OPTION, hDlg, %ID_Annual, "Annual", 10, n + 110, 40, 10, %WS_GROUP
   CONTROL SET COLOR hDlg, %ID_Annual, %Black, %White
   CONTROL ADD OPTION, hDlg, %ID_MonthlyPer, "Monthly period", 10, n + 120, 70, 10
   CONTROL SET COLOR hDlg, %ID_MonthlyPer, %Black, %White
   CONTROL ADD OPTION, hDlg, %ID_WeeklyPer, "Weekly period", 10, n + 130, 70, 10         
   CONTROL SET COLOR hDlg, %ID_WeeklyPer, %Black, %White
   CONTROL ADD OPTION, hDlg, %ID_WeekdayMos, "Weekday months", 10, n + 140, 70, 10
   CONTROL SET COLOR hDlg, %ID_WeekdayMos, %Black, %White
   CONTROL ADD FRAME, hDlg, %ID_Freq, "Event frequency", 5, n + 87, 85, 68, %WS_GROUP
   CONTROL SET COLOR hDlg, %ID_Freq, %Black, %White
   control add button, hDlg, %ID_New, "Ne&w", 112, n + 92, 36, 20
   IF reminderNo THEN s = "&Replace" ELSE s = "&Add"
   control add button, hDlg, %ID_Cancel, "&Cancel", 149, n+92, 36, 20
   CONTROL ADD BUTTON, hDlg, %ID_Add, s, 112, n + 113, 36, 20
   CONTROL ADD BUTTON, hDlg, %ID_Del, "&Delete", 149, n + 113, 36, 20
   control add button, hDlg, %ID_Next, "&Next", 230, n + 10, 50, 25
   control add button, hDlg, %ID_Prev, "&Prev", 230, n + 36, 50, 25
   control add button, hDlg, %ID_List, "&List", 230, n + 74, 50, 25                  
   control add button, hDlg, %ID_Settings, "&Settings", 230, n + 100, 50, 25
   control add button, hDlg, %ID_Help, "&Help", 230, n + 126, 50, 25               
   CONTROL ADD STATUSBAR, hDlg, %ID_Status, "", 0, 0, 0, 0
   statusbar set parts hDlg, %ID_Status, 200, 75, 9999
   DIALOG SHOW MODAL hDlg CALL myRemindersProc
end function                             

CALLBACK FUNCTION myRemindersProc                                                       
   LOCAL i, n, mov, day, nEvent, nDate, nOpt, hdc, hInst, hIcon AS LONG
   local n1, n2, n3, n4, n5 as long
   LOCAL k, m AS QUAD
   LOCAL s, ss, s0, s1, s2, s3, s4, s5 AS STRING                          
   local ps AS PAINTSTRUCT                                                                           
   local remind, lastReminder AS reminderType
   STATIC mo, yr, closing, savDate AS LONG
   SELECT CASE CBMSG                                                  
      CASE %WM_INITDIALOG
         hInst = GetModuleHandle(BYVAL %NULL)
         hIcon = LoadImage(hInst, "Alight", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
         DIALOG SEND hDlg, %WM_SETICON, 0, hIcon
         array assign weekDays() = "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"

         progDataFolder = specialFolder(%CSIDL_COMMON_APPDATA) 'ProgramData folder
         if isFolder(progDataFolder + "\cgdSoftware\myReminders") = 0 then              
            mkdir progDataFolder + "\cgdSoftware"
            mkdir progDataFolder + "\cgdSoftware\myReminders\"             
         end if 
         progDataFolder = progDataFolder + "\cgdSoftware\myReminders"
         iniFile = progDataFolder + "\myReminders.ini"
         helpFile = progDataFolder + "\myReminders.ahp"
                                                                              
         myDataFolder = specialFolder(%CSIDL_PERSONAL) 'Chuck Documents folder
         if isFolder(myDataFolder + "\cgdSoftware\myReminders") = 0 then
            mkdir myDataFolder + "\cgdSoftware"
            mkdir myDataFolder + "\cgdSoftware\myReminders"             
         end if
         myDataFolder = myDataFolder + "\cgdSoftware\myReminders"
         
         'get dataFile and dataFolder
         dataFile = command$(1)
         if len(dataFile) = 0 and isfile(iniFile) then
            open iniFile for input as #1
            reset dataFile
            input #1, dataFile
            close #1                                    
         end if 
         if isFile(dataFile) = 0 then
            dataFile = myDataFolder + "\myReminders.rmd" 
         end if 
         dataFolder = pathname$(path, dataFile)                       
         
         openReminders
         mo = VAL(LEFT$(DATE$, 2))                                 
         yr = VAL(RIGHT$(DATE$, 4))
         today = VAL(MID$(DATE$, 4, 2))
         thisMo = mo: thisYr = yr                                                  
         theMo = mo: theDay = 0: theYr = yr       
         xMouse = 0: yMouse = 0
         reminderNo = 0
         activateBtns 0
         control hide cb.hndl, %ID_Period
         control hide cb.hndl, %ID_Period0
         control set option cb.hndl, %ID_OneTime, %ID_OneTime, %ID_WeekdayMos
         control disable cb.hndl, %ID_Prev
         DIALOG POST CB.HNDL, %WM_USER + 500, 0, 0                    
      CASE %WM_USER + 500
         updateReminders
         multReminders()
         statusbar set text hDlg, %ID_Status, 1, 0, dataFile
      case %WM_Paint                                                  
         initCalendar              
         showMonths TheMo, theYr
      CASE %WM_COMMAND
         if cb.ctl = %IDC_LeftArrow then
            theMo = theMo - 2: nArrow = 1 
            IF theMo < 1 THEN theMo = theMo + 12: DECR theYr           
            clearForm: clearMonths: initCalendar: showMonths theMo, theYr                             
         elseif cb.ctl = %IDC_RightArrow then
            theMo = theMo + 2: nArrow = 1 
            IF theMo > 12 THEN theMo = theMo - 12: INCR theYr
            clearForm: clearMonths: initCalendar: showMonths theMo, theYr
         elseif cb.ctl = %ID_New then           
            clearForm: reminderNo = 0
            s = trim$(str$(selMo)) + "-" + trim$(str$(selDay)) + "-" + trim$(str$(selYr))
            control set text cb.hndl, %ID_Date, s
            activateBtns 2
         elseif cb.ctl = %ID_Cancel then
            if savReminderNo then reminderNo = savReminderNo: savReminderNo = 0
            if reminderNo then 
               fillForm(reminderNo): activateBtns 4 
            else
               clearForm: activateBtns 1
            end if    
            if reminderNo = numReminders then control disable cb.hndl, %ID_Next
            if reminderNo = 1 then control disable cb.hndl, %ID_Prev    
         elseif cb.ctl = %ID_Add then
            n = UBOUND(myReminders)
            IF numReminders = n THEN
               redim preserve myReminders(n + 200)
               redim preserve remindersArch(n + 200) 
            END IF
            CONTROL GET TEXT CBHNDL, %ID_Event TO s0: s0 = trim$(s0)
            combobox find exact CB.HNDL, %ID_Event, 1, s0 to nEvent                         
            CONTROL GET TEXT CBHNDL, %ID_Descr TO s1
            CONTROL GET TEXT CBHNDL, %ID_Date TO s2
            if len(s2) then
               s = invalidDate(s2)
               control set text cb.hndl, %ID_Date, s2
               IF len(s) THEN
                  MSGBOX s, %MB_OK + %MB_ICONerror, "Invalid Date"     
                  CONTROL SET FOCUS CBHNDL, %ID_Date: EXIT FUNCTION
               END IF
            end if                                                                
            CONTROL GET TEXT CBHNDL, %ID_Notify TO s3: n3 = val(s3)          
            CONTROL GET TEXT CBHNDL, %ID_Time TO s4
            CONTROL GET TEXT CBHNDL, %ID_Period TO s5: n5 = max(1, val(s5))
            FOR i = 1 TO 6
               CONTROL GET CHECK CB.HNDL, %ID_OneTime + i - 1 TO n
               IF n THEN nOpt = i: EXIT FOR
            NEXT i                        
            IF n3 > 30 THEN
               MSGBOX "Maximum of 30 days", %MB_OK + %MB_ICONERROR, "Reminder Form"
               CONTROL SET FOCUS CBHNDL, %ID_Notify: EXIT FUNCTION
            END IF
            IF nEvent > 2 and LEN(s4) THEN 'store time as military time
               m = instr(s4, ":"): if m then mid$(s4, m) = "."
               if instr(s4, "am") then ss = "am"
               if instr(s4, "pm") then ss = "pm"
               if len(ss) then s4 = extract$(s4, ss)
               n4 = 100 * val(s4)
               IF n4 > 1259 THEN
                  MSGBOX "Bad time format", %MB_OK + %MB_ICONERROR, "Reminder Form"
                  CONTROL SET FOCUS CBHNDL, %ID_Time: EXIT FUNCTION
               END IF 
               IF ss = "pm" THEN
                  IF n4 >= 100 THEN n4 = n4 + 1200                            
               elseif ss = "am" THEN                
                  if n4 = 1200 then n4 = 2400
               else
                  n4 = 0                                    
               END IF 
            elseif nEvent <= 2 then
               n4 = val(s4)   
            END IF 
            if s0 = "appointment" or s0 = "meeting" then n = n4 else n = 1
            IF LEN(s0) = 0 OR len(s1) = 0 or LEN(s2) = 0 or n = 0 or len(s3) = 0 THEN
               s = "Must fill all fields"
               if n = 0 then s = s + $CRLF + "... and time must include am or pm"
               MSGBOX s, %MB_OK + %MB_ICONINFORMATION, "Reminder Form"
               CONTROL SET FOCUS CBHNDL, %ID_Event: EXIT function
            END IF
            remind.nEvent = cbyt(nEvent)
            remind.descr = s1                                                  
            yr = VAL(RIGHT$(s2, 4))                                  
            mo = val(left$(s2, 2)) 
            day = VAL(MID$(s2, 4, 2))
            remind.date = newDate(yr, mo, day)
            remind.time = cint(n4)
            remind.adv = CBYT(n3)
            remind.period = cbyt(VAL(s5))
            remind.freq = CBYT(nOpt)                                                 
            IF reminderNo THEN 'edited reminder... delete it now
               ARRAY DELETE myReminders(reminderNo): DECR numReminders
            END IF
            k = remind.date
            n = 0
            FOR i = 1 TO numReminders 'find insert position
               IF k < myReminders(i).date THEN n = i: EXIT FOR
            NEXT i
            if numReminders and n > 0 then                                         
               lastReminder = myReminders(numReminders)
               array insert myReminders(n), remind 'last reminder is lost here
               incr numReminders: myReminders(numReminders) = lastReminder
            else                                                                       
               incr numReminders: n = numReminders                                                           
               myReminders(numReminders) = remind
            end if
            reminderNo = n                              
            fileChanged = 1: formChanged = 0        
            calendarPos s2
            activateBtns 4
            multReminders                  
            'setStatusbar
            s = "  Reminder" + str$(reminderNo) + " of" + str$(numReminders) 
            statusbar set text hDlg, %ID_Status, 2, 0, s
            m = multReminds(n)
            if m then s = str$(m) else s = ""
            statusbar set text hDlg, %ID_Status, 3, 0, s
         elseif cb.ctl = %ID_Del then
            if reminderNo then
               s = "Delete this reminder now"
               n = msgbox(s, %MB_YESNOCANCEL or %MB_iconwarning, " ")
               if n = %IDYes then
                  k = myReminders(reminderNo).date
                  array delete myReminders(reminderNo)
                  decr numReminders
                  reminderNo = min(reminderNo, numReminders)
                  if myReminders(reminderNo).date <> k then clearForm else fillForm reminderNo
                  if reminderNo > 1 and myReminders(reminderNo - 1).date = k then decr reminderNo: fillForm reminderNo
                  showMonths theMo, theYr
                  multReminders               
                  fileChanged = 1
                  activateBtns 1                         
                  m = multReminds(reminderNo): if m then s = str$(m) else s = ""
                  statusbar set text hDlg, %ID_Status, 3, 0, s                        
               end if
            end if
         elseif cb.ctl = %ID_Next or cb.ctl = %ID_Prev then
            nextPrev = 1
            if savDate and reminderNo = 0 then                                     
               reminderNo = 0 
               for i = 2 to numReminders
                  m = myReminders(i-1).date: 
                  n = myReminders(i).date
                  if m <= savDate and savDate <= n then k = i: exit for 
               next i
               if cb.ctl = %ID_Next then reminderNo = k else reminderNo = k - 1
               if savDate < myReminders(1).date and cb.ctl = %ID_Next then reminderNo = 1
               if savDate > myReminders(numReminders).date and cb.ctl = %ID_Prev then reminderNo = numReminders
            else   
               if cb.ctl = %ID_Next then incr reminderNo else decr reminderNo
            end if
            if reminderNo >= 1 and reminderNo <= numReminders then
               nextPrev = 1
               control enable cb.hndl, %ID_Next
               control enable cb.hndl, %ID_Prev
               m = myReminders(reminderNo).date: s = trim$(str$(m)) 
               s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)
               xMouse = 0: yMouse = 0                                                      
               calendarPos(s)
               fillForm(reminderNo)
               activateBtns 4
               nextPrev = 0                                      
               if reminderNo = numReminders then control disable cb.hndl, %ID_Next
               if reminderNo = 1 then control disable cb.hndl, %ID_Prev
            end if
         elseif cb.ctl = %ID_List then
            listReminders               
         elseif cb.ctl = %ID_Help then
            appHelp helpFile, "myReminders Help", cb.hndl, 100, 100
         elseif cb.ctl = %ID_settings then
            settings() 
         ELSEIF CB.CTL = %ID_Event THEN
            IF CBCTLMSG = %CBN_SELENDOK THEN
               combobox get select cb.hndl, %ID_Event to nEvent
               IF nEvent THEN
                  if nEvent <= 2 then                                           
                     s = "year"
                     CONTROL SET TEXT CB.HNDL, %ID_Time0, s
                     nOpt = 2
                     for i = 1 to 6
                        control set check cb.hndl, 220 + i, 0
                     next i                                                
                     control set check cb.hndl, %ID_Annual, 1
                  else
                     s = "time"
                     CONTROL SET TEXT CB.HNDL, %ID_Time0, s 
                     nOpt = 1                                      
                     for i = 1 to 6
                        control set check cb.hndl, 220 + i, 0
                     next i
                     control set check cb.hndl, %ID_Onetime, 1
                  end if
               END IF 
               showPeriod nOpt
               if formDone then formChanged = 1: formDone = 0
               CONTROL SET FOCUS CBHNDL, %ID_Descr
            elseif cb.ctlmsg = %CBN_editchange then
               control get text cb.hndl, %ID_Event to s
               combobox find cb.hndl, %ID_Event, 1, s to n
               if n = 0 then control set text cb.hndl, %ID_Event, ""  
            END IF
         ELSEIF CBCTL = %ID_Descr AND CBCTLMSG = %EN_CHANGE THEN
            hdc = GetDC(CB.HNDL)
            CONTROL GET TEXT CBHNDL, %ID_Descr TO s
            IF stringSize(hDC, s) > 300 THEN
               CONTROL SET TEXT CBHNDL, %ID_Descr, truncateStr(hdc, s, 300)
               CONTROL SEND CBHNDL, %ID_Descr, %EM_SETSEL, -LEN(s), LEN(s)     
            END IF
            if reminderNo then activateBtns 3 else activateBtns 2
         elseif cb.ctl = %ID_Date AND CBCTLMSG = %EN_CHANGE THEN
            if reminderNo then activateBtns 3 else activateBtns 2
         elseif cb.ctl = %ID_Notify or cb.ctl = %ID_Time or cb.ctl = %ID_Period then
            if CBCTLMSG = %EN_CHANGE then                                               
               if reminderNo then activateBtns 3 else activateBtns 2
            end if  
         elseif cb.ctl >= %ID_OneTime and cb.ctl <= %ID_OneTime + 5 then
            nOpt = cb.ctl - %ID_OneTime + 1                                       
            showPeriod nOpt                                                        
            if reminderNo then activateBtns 3 else activateBtns 2
         end if 
         if cb.ctl >= %ID_New and cb.ctl <= %ID_Settings then                              
            CONTROL SEND CBHNDL, CBCTL, %BM_SETSTYLE, %BS_PUSHBUTTON, %TRUE
         end if
      CASE %WM_LBUTTONDOWN
         leftBtnDn = 1
         if editing then exit function                                           
         xMouse = LOWRD(CBLPARAM): yMouse = HIWRD(CBLPARAM)
         mo = theMo: yr = theYr 
         if xMouse > 220 then incr mo: if mo > 12 then mo = 1: incr yr
         if yMouse < 220 then showMonths theMo, theYr 
         day = theDay: savDate = newDate(yr, mo, day)
         if savDate > myReminders(numReminders).date then control disable cb.hndl, %ID_Next
         if savDate < myReminders(1).date then control disable cb.hndl, %ID_Prev
         n = 0: s = ""                                                                                      
         for i = 1 to numReminders                                           
            if myReminders(i).date = savDate then n = i: exit for
         next i
         if n then s = "  Reminder" + str$(n) + " of" + str$(numReminders) 
         statusbar set text hDlg, %ID_Status, 2, 0, s
         if n then m = multReminds(n): if m then s = str$(m) else s = ""        
         statusbar set text hDlg, %ID_Status, 3, 0, s
         reminderNo = n 
      CASE %WM_LBUTTONDBLCLK                                         
         'this routine copies the date to the form
         control get text cb.hndl, %ID_Date to s
         if editing and len(s) then exit function 
         savReminderNo = reminderNo: 
         if reminderNo then clearForm: reminderNo = 0       
         dblClk = 1
         xMouse = LOWRD(CBLPARAM): yMouse = HIWRD(CBLPARAM)
         mo = theMo: yr = theYr: if xMouse > 220 then incr mo
         if mo > 12 then mo = 1: incr yr 
         showMonths theMo, theYr
         s = right$("0" + trim$(str$(mo)), 2)
         s = s + "-" + right$("0" + trim$(str$(theDay)), 2)
         s = s + "-" + right$(str$(yr), 2)
         control set text cbhndl, %ID_Date, s                               
         s = weekDays(dayOfWeek(mo, yr, theDay))                
         control set text cb.hndl, %ID_Weekday, trim$(s)
         dblclk = 0                           
      CASE %WM_SYSCOMMAND                  
         IF CBCTL = %SC_CLOSE THEN 
            if closing then function = 1: exit function
            closing = 1
            IF fileChanged THEN 
               s = "File has changed..." + $CRLF + "Do you want to save the changes?"
               n = MSGBOX(s, %MB_YESNOCANCEL + %MB_ICONWARNING, "Closing Reminders")
               IF n = %IDYES THEN
                  saveReminders
               elseif n = %IDCANCEL THEN
                  closing = 0: FUNCTION = 1: EXIT FUNCTION              
               end if
            END IF 
            fileChanged = 0: closing = 0 
            DIALOG END cb.hndl
         END IF                                      
   end select
end function

FUNCTION alreadyRunning(hMutex AS LONG, mutexName AS ASCIIZ *64) AS LONG
   'check if instance of program is already running
   'Returns: 1  already running
   '         0  first instance 
   hMutex = CreateMutex (BYVAL %NULL, %FALSE, BYVAL VARPTR(mutexName))
   IF hMutex THEN 'got a handle, but was it already existing?
      IF GetLastError = %Error_Already_Exists THEN FUNCTION = 1
   END IF
END FUNCTION

sub fillForm(k as long)
   'k is the reminder number
   formDone = 0
   local n, i, nOpt, mo, day, yr, nEvent as long 
   local s, ss, daysOfTheWeek as string
   daysOfTheWeek = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday"
   reminderNo = k
   control set text hDlg, %ID_Add, "Replace"
   nEvent = myReminders(k).nEvent
   control set text hDlg, %ID_Event, nEvents(nEvent) 
   CONTROL SET TEXT hDlg, %ID_Descr, myReminders(k).Descr
   s = trim$(str$(myReminders(k).date))
   s = mid$(s, 5, 2) + "-" + right$(s, 2) + "-" + left$(s, 4)   
   if myReminders(k).date then
      control set text hDlg, %ID_Date, s 
   end if
   mo = val(left$(s, 2)): yr = val(right$(s, 4)): day = val(mid$(s, 4, 2))
   s = weekDays(dayOfWeek(mo, yr, day))                     
   control set text hDlg, %ID_Weekday, trim$(s)       
   n = myReminders(k).time 'military time
   if n then 
      if nEvent > 2 then 
         s = trim$(str$(n))                                                  
         if n >= 1200 then ss = " pm" else ss = " am"                  
         if n = 2400 then ss = " am"
         if n >= 1300 then n = n - 1200
         s = trim$(str$(n))
         s = left$(s, len(s)-2) + ":" + right$(s, 2) + ss
         control set text hDlg, %ID_Time0, "time:"
         control set text hDlg, %ID_Time, s
      else
         control set text hDlg, %ID_Time0, "year:"
         control set text hDlg, %ID_Time, trim$(str$(n))
      end if
   end if
      
   n = myReminders(k).Adv: s = trim$(str$(n))
   control set text hDlg, %ID_Notify, s
   nOpt = myReminders(k).freq
   for i = 1 to 6
      control set check hDlg, 220 + i, 0
   next i 
   control set check hDlg, 220 + nOpt, 1
   n = myReminders(k).period: s = trim$(str$(n))
   control set text hDlg, %ID_period, s
   if nOpt < 3 then control hide hDlg, %ID_Period 
   showPeriod nOpt
   formDone = 1
end sub                                                                                       

SUB showPeriod(nOpt AS LONG)
   'Show monthly day such as "Third monday"
   '     or define monthly, weekly
   '-----------------------------------------------------------------------------
   LOCAL s, s1, nth, daysOfTheWeek AS STRING
   LOCAL day, mo, yr, thisDay, thisMonth, n AS LONG
   'must be valid date ----------------------------;
   control get text hDlg, %ID_Date to s            
   if len(invalidDate(s)) then exit sub            
   '-----------------------------------------------'
   daysOfTheWeek = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday"
   CONTROL GET TEXT hDlg, %ID_Date TO s
   mo = VAL(PARSE$(s, any "-/", 1))                   
   day = VAL(PARSE$(s, any "-/", 2))                                 
   yr = VAL(PARSE$(s, any "-/", 3))
   IF nOpt = 3 or nOpt = 4 THEN
      if nOpt = 3 then s = "months"
      if nOpt = 4 then s = "weeks"
   elseIF nOpt = 5 or nOpt = 6 THEN   
      nth = "1st 2nd 3rd 4th"
      n = dayOfWeek(mo, yr, day)
      s = PARSE$(daysOfTheWeek, " ", n + 1)
      n = day \ 7 + SGN(day MOD 7): s1 = PARSE$(nth, " ", n)
      s = s1 + " " + s
      if nOpt = 5 then s = "months" + $crlf + s
      if nOpt = 6 then s = "weeks" + $crlf + s
   ELSE                                                                          
      control hide hDlg, %ID_Period
      control hide hDlg, %ID_Period0
      exit sub                                      
   END IF
   control normalize hDlg, %ID_Period
   control normalize hDlg, %ID_Period0
   control set text hDlg, %ID_Period0, s                    
END SUB

sub clearForm
   control set text hDlg, %ID_Event, ""
   control set text hDlg, %ID_Descr, ""
   control set Text hDlg, %ID_Date, ""
   control set text hDlg, %ID_Weekday, ""
   control set Text hDlg, %ID_Time, ""
   control set Text hDlg, %ID_Notify, ""
   control set Text hDlg, %ID_Period, ""
   control set Text hDlg, %ID_Period0, ""
   control hide hDlg, %ID_Period
   control hide hDlg, %ID_Period0
   control set option hDlg, %ID_OneTime, %ID_OneTime, %ID_WeekdayMos 
end sub

function dateVal(sDate as string) as long
   local mo, day, yr as long                              
   mo = val(parse$(sDate, any "-/", 1))
   day = val(parse$(sDate, any "-/", 2))                                    
   yr = val(parse$(sDate, any "-/", 3))                      
   function = 10000*yr + 100*mo + day
end function

FUNCTION invalidDate(s AS STRING) AS string
   'valid dates: 10-13-2023 or 10/13/2023           
   '             10-13-23   or 10/13/23
   '             10-13      or 10/23
   '----------------------------------------------
   LOCAL s1, s2, s3, ss AS STRING                  
   LOCAL n1, n2, n3, invalid, sVal, dVal AS LONG    
   REPLACE "/" WITH "-" IN s
   s1 = PARSE$(s, any "-/", 1): n1 = VAL(s1)
   s2 = PARSE$(s, any "-/", 2): n2 = VAL(s2)                                     
   s3 = PARSE$(s, any "-/", 3)
   if len(s3) = 2 then s3 = "20" + trim$(s3): n3 = VAL(s3)
   if len(s3) = 0 then s3 = s3 + right$(Date$, 4)
   n3 = VAL(s3): s3 = trim$(str$(n3))
   s = RIGHT$("0" + s1, 2) + "-" + RIGHT$("0" + s2, 2) + "-" + s3
   dVal = dateVal(date$)  'VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))
   sVal = dateVal(s)      'n3*10000 + n1*100 + n2 'incoming s-value
   IF n1 < 1 or n1 > 12 THEN                                   
      ss = "Month out of range"
   ELSEIF n2 < 1 or n2 > daysInMonth(n1, n3) or sVal < dVal THEN
      ss = "Incorrect day specified (must be after today)"
   elseif n3 < 2000 or n3 >= 2100 then
      ss = "year Must be this 21st century"
   else
      ss = ""      
   END IF
   function = ss
END FUNCTION
                                                    
sub ListReminders()                                                         
   LOCAL nStyle, wi, ht AS LONG
   local ti as string
   wi = 410: ht = 250 
   ti = "List of myReminders"
   DIALOG NEW hDlg, ti, 70, 40, wi, ht, %WS_SYSMENU TO hList
   nStyle=%WS_VSCROLL + %LBS_DISABLENOSCROLL + %WS_TABSTOP + %LBS_USETABSTOPS
   CONTROL ADD LISTBOX, hList, %ID_ListReminders, , 10, 20, 400, 175, nStyle, %WS_EX_CLIENTEDGE
   CONTROL ADD BUTTON, hList, %ID_Header, "Date", 10, 10, 50, 10, %BS_LEFT
   CONTROL ADD BUTTON, hList, %ID_Header, "Day", 60, 10, 30, 10, %BS_CENTER      
   CONTROL ADD BUTTON, hList, %ID_Header, "Time", 90, 10, 40, 10, %BS_CENTER
   CONTROL ADD BUTTON, hList, %ID_Header, "Event",130, 10, 50, 10,  %BS_LEFT                
   CONTROL ADD BUTTON, hList, %ID_Header, "Description", 180, 10, 215, 10, %BS_LEFT
   CONTROL ADD BUTTON, hList, %ID_Header, "Notify", 370, 10, 30, 10, %BS_LEFT 
   CONTROL ADD BUTTON, hList, %ID_Back, "&Back", 160, 200, 50, 20
   control add button, hList, %ID_Delete, "Delete", 220, 200, 50, 20
   CONTROL ADD BUTTON, hList, %ID_Print, "&Print", 280, 200, 50, 20
   control add button, hList, %ID_Close, "&Close", 340, 200, 50, 20
   nStyle = %BS_Notify
   control add option, hList, %ID_Current, "C&urrent", 25, 195, 50, 12, nStyle
   control add option, hList, %ID_Archive, "&Archive", 25, 207, 50, 12, nStyle
   control set option hList, %ID_Current, %ID_Current, %ID_Archive
   DIALOG SHOW MODAL hList CALL listRemindersProc
END sub
                                                                                        
CALLBACK FUNCTION listRemindersProc                
   LOCAL i, m, n, mo, year, day, hdc, num AS LONG                                                                             
   LOCAL s, ss, t AS STRING                      
   LOCAL sTxt AS ASCIIZ * 100                                              
   SELECT CASE CBMSG                     
      CASE %WM_INITDIALOG                     
         listMode = 1
         DIM lptr AS LONG PTR                                               
         DIM tabstops(0 to 5) AS LONG
         tabstops(0) = 0     'date                                     
         tabstops(1) = 55    'day of week           
         tabstops(2) = 85    'time                       
         tabstops(3) = 124   'event
         tabstops(4) = 170   'descr
         tabstops(5) = -375  'notify
         lptr=VARPTR(tabstops(0))
         CONTROL SEND cb.hndl, %ID_ListReminders, %LB_SETTABSTOPS, 6, lptr
         'control set option hList, %ID_Current, %ID_Current, %ID_Archive
         DIALOG POST CB.HNDL, %WM_COMMAND, %ID_Current, 0
      CASE %WM_COMMAND
         if cb.ctl = %ID_ListReminders then
            if archiveMode then num = numArchives else num = numReminders
            listbox get select cb.hndl, %ID_ListReminders to n
            if n then 
               control enable cb.hndl, %ID_Back
               s = "  Reminder" + str$(n) + " of" + str$(num) 
               statusbar set text hDlg, %ID_Status, 2, 0, s
               m = multReminds(n): if m then s = str$(m) else s = ""
               statusbar set text hDlg, %ID_Status, 3, 0, s
            end if          
         elseif cb.ctl = %ID_Current then
            archiveMode = 0                                          
            LISTBOX RESET cb.hndl, %ID_ListReminders
            FOR i = 1 TO numReminders
               n = myReminders(i).date: m = 0: s = TRIM$(STR$(n)): t = ""
               mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2)): year = VAL(LEFT$(s, 4))
               weekDay = MID$(daysInWeek, 4 * dayOfWeek(mo, year, day) + 1, 3)
               IF myReminders(i).nEvent > 2 THEN m = myReminders(i).time
               IF m >= 1200 THEN ss = " pm" ELSE ss = " am"
               IF m >= 1300 THEN
                  m = m - 1200                                                       
               ELSEIF m AND m < 100 THEN              
                  m = 1200 + m                                      
               END IF
               IF m THEN t = FORMAT$(m\100, "##") + ":" + FORMAT$(m MOD 100, "00") + ss
               s = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + LEFT$(s, 4)
               s = s + $TAB + weekDay
               s = s + $TAB + t
               s = s + $TAB + TRIM$(nEvents(myReminders(i).nEvent))               
               hdc = GetDC(hList)
               s = s + $TAB + truncateStr(hdc, TRIM$(myReminders(i).descr), 300)
               s = s + $TAB + STR$(myReminders(i).adv)
               listbox add cb.hndl, %ID_ListReminders, s
            NEXT i
            control normalize cbhndl, %ID_Back
            control normalize cb.hndl, %ID_Print
            if editing then control hide cb.hndl, %ID_Back
            if reminderNo then listbox select cb.hndl, %ID_ListReminders, reminderNo
         elseif cb.ctl = %ID_Archive then
            archiveMode = 1
            LISTBOX RESET hList, %ID_ListReminders                                             
            FOR i = 1 TO numArchives
               n = remindersArch(i).date: m = 0: s = TRIM$(STR$(n)): t = ""
               mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2)): year = VAL(LEFT$(s, 4))
               weekDay = MID$(daysInWeek, 4 * dayOfWeek(mo, year, day) + 1, 3)
               IF remindersArch(i).nEvent > 2 THEN m = remindersArch(i).time
               IF m >= 1200 THEN ss = " pm" ELSE ss = " am"                    
               IF m >= 1300 THEN
                  m = m - 1200                                                
               ELSEIF m AND m < 100 THEN              
                  m = 1200 + m                                      
               END IF
               IF m THEN t = FORMAT$(m\100, "##") + ":" + FORMAT$(m MOD 100, "00") + ss
               s = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + LEFT$(s, 4)
               s = s + $TAB + weekDay
               s = s + $TAB + t
               n = remindersArch(i).nEvent       
               s = s + $TAB + TRIM$(nEvents(n))           
               hdc = GetDC(hList)
               s = s + $TAB + truncateStr(hdc, TRIM$(remindersArch(i).descr), 300)
               s = s + $TAB + STR$(remindersArch(i).adv)
               listbox add cb.hndl, %ID_ListReminders, s
            NEXT i
            control hide cb.hndl, %ID_Back
         elseif cb.ctl = %ID_Delete then
            listbox get select cb.hndl, %ID_ListReminders to n
            if n = 0 then exit function
            s = "Delete this reminder now"
            m = msgbox(s, %MB_YESNO or %MB_iconwarning, myReminders(n).descr)
            if m = %IDYes then
               listbox delete cb.hndl, %ID_ListReminders, n
               if archiveMode = 0 then
                  array delete myReminders(n): decr numReminders
               else   
                  array delete remindersArch(n): decr numArchives
               end if
               fileChanged = 1
            end if   
         elseif cb.ctl = %ID_Back then                                     
            listbox get select cb.hndl, %ID_ListReminders to n 
            if n = 0 then
               listMode = 0: dialog end cb.hndl: exit function                      
            end if
            reminderNo = n                  
            m = myReminders(n).date: s = trim$(str$(m)) 
            s = MID$(s, 5, 2) + "-" + RIGHT$(s, 2) + "-" + LEFT$(s, 4)    
            xMouse = 0: yMouse = 0
            listMode = 0
            dialog end cb.hndl                                       
            calendarPos(s)
            fillForm(n)
            activateBtns 4
         elseif cb.ctl = %ID_Print then
            printReminders                                                  
            CONTROL SET FOCUS cb.hndl, %ID_ListReminders
         elseif cb.ctl = %ID_Close then
            listMode = 0
            dialog end cb.hndl                                                       
         end if                    
      CASE %WM_SYSCOMMAND                  
         IF CBCTL = %SC_CLOSE THEN
            listMode = 0
            dialog end cb.hndl               
         end if                     
   END SELECT
END function

sub settings()
   LOCAL nStyle, wi, ht AS LONG
   local ti, s as string
   wi = 250: ht = 160 
   ti = "Settings for myReminders"
   DIALOG NEW hDlg, ti, 70, 40, wi, ht, %WS_SYSMENU TO hSettings 
   DIALOG SET COLOR hSettings, -1, %WHITE
   control add label, hSettings, -1, "Default data file location:", 10, 15, 150, 10
   CONTROL SET COLOR hSettings, -1, %Black, %White
   control add button, hSettings, %ID_ShowLoc, "Current Location", 30, 30, 120, 15
   control add button, hSettings, %ID_SetLoc, "Set new Location", 30, 50, 120, 15
   control add button, hSettings, %ID_Reset, "Reset settings", 170, 110, 70, 25
   DIALOG SHOW MODAL hSettings CALL settingsProc
end sub 

CALLBACK FUNCTION settingsProc
   local n as long
   local s, ss, dataFile0 as string
   SELECT CASE CBMSG                     
      CASE %WM_INITDIALOG                                                        
      CASE %WM_COMMAND
         if cb.ctl = %ID_ShowLoc then
            myMsgbox(dataFile, -(%mb_iconinformation), "Data File Location", 1, 100, 100)
            dialog end cb.hndl
         elseif cb.ctl = %ID_SetLoc then
            'set new location for dataFile               
            ss = "set new Folder for DataFile"
            DISPLAY browse cb.hndl, 100, 100, ss, dataFolder, 0 TO s 
            if len(s) then
               dataFile0 = dataFolder + "\myreminders.rmd"
               dataFile = s + "\myReminders.rmd": dataFolder = s
               open iniFile for OUTput as #1
               print #1, dataFile;          
               close #1
               n = getFileLength(dataFile0)
               if n > 16 then filecopy dataFile0, dataFile
               statusbar set text hDlg, %ID_Status, 1, 0, dataFile
               sleep 100                    
               dialog end cb.hndl 
               openReminders                                                      
            end if
         elseif cb.ctl = %ID_Reset then 
            dataFile0 = dataFolder + "\myreminders.rmd"
            dataFile = myDataFolder + "\myReminders.rmd": dataFolder = myDataFolder
            open iniFile for OUTput as #1
            print #1, dataFile;                          
            close #1
            n = getFileLength(dataFile0)
            if n > 16 then filecopy dataFile0, dataFile
            statusbar set text hDlg, %ID_Status, 1, 0, dataFile
            sleep 100
            dialog end cb.hndl 
            openReminders 
         end if
   end select      
end function
                                                            
FUNCTION GetFileLength(sFileName AS STRING) as dword
    LOCAL W32FD AS WIN32_FIND_DATA
    LOCAL hFile AS DWORD
    IF LEN(sFileName) = 0 THEN EXIT FUNCTION
    hFile = FindFirstFile(BYVAL STRPTR(sFileName), W32FD)
    IF hFile <> %INVALID_HANDLE_VALUE THEN
       FUNCTION = W32FD.nFileSizeHigh * &H0100000000 + W32FD.nFileSizeLow
    END IF
    FindClose hFile
END FUNCTION

sub openReminders 
   LOCAL i, fileNum AS LONG                      
   LOCAL ver AS STRING
   fileNum = FREEFILE
   OPEN dataFile FOR BINARY AS fileNum                       
   ver = $version                                                               
   get #fileNum,, ver
   get #fileNum,, numReminders
   FOR i = 1 TO numReminders                                                                           
      get #fileNum,, myReminders(i)
   NEXT i                                                                                       
   get #fileNum,, numArchives 
   FOR i = 1 TO numArchives
      get #fileNum,, remindersArch(i)
   NEXT i
   CLOSE #fileNum                                                                          
end sub

SUB saveReminders 
   LOCAL i, fileNum AS LONG                      
   LOCAL ver AS STRING                             
   fileNum = FREEFILE 
   OPEN dataFile FOR BINARY AS fileNum                       
   ver = $version
   PUT #fileNum,, ver
   PUT #fileNum,, numReminders
   FOR i = 1 TO numReminders
      PUT #fileNum,, myReminders(i)                            
   NEXT i
   PUT #fileNum,, numArchives                      
   FOR i = 1 TO numArchives
      PUT #fileNum,, remindersArch(i)                            
   NEXT i 
   CLOSE #fileNum
END SUB                                                

SUB updateReminders()                                   
   'update past due reminders                     
   LOCAL i, j, n, n0, ith, day, mo, yr, valToday, valLastMo, numUpdates, numArch, num AS LONG
   local k, m AS QUAD                                       
   LOCAL s AS STRING
   local remind, lastReminder as reminderType
                                                                   
   'first, let's keep one month of nonrepeating events --------------------------------------;
   valToday = VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))
   mo = val(left$(date$, 2)): yr = val(RIGHT$(DATE$, 4)) 
   decr mo: if mo < 1 then mo = 12: decr yr
   valLastMo = VAL(trim$(str$(yr)) + format$(mo, "00") + MID$(DATE$, 4, 2))
   for j = numArchives to 1 step -1                               
      if remindersArch(j).date < valLastMo then 
         array delete remindersArch(j): decr numArchives
      end if
   next j
   n = numArchives
   for j = 1 to numReminders
      if myReminders(j).date >= valToday then exit for 'don't archive for today or after
      if myReminders(j).nEvent < 3 then iterate 'don't archive birtdays or anniversaries
      if myReminders(j).freq > 1 then iterate 'don't archive repeating events
      remindersArch(n + j) = myReminders(j): incr numArchives
   next j
   saveReminders()
   '-----------------------------------------------------------------------------------------'
   num = numReminders
   for j = 1 to num
      if myReminders(j).date >= valToday then exit for 
      incr numUpdates
      s = TRIM$(STR$(myReminders(j).Date))
      yr = VAL(LEFT$(s, 4)): mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2))               
      k = myReminders(j).freq                                                         
      IF k = 1 THEN 'update one time only                                                  
         iterate
      elseIF k = 2 THEN 'update to next year                                                    
         INCR yr
      ELSEIF k = 3 THEN 'update to future month, same day
         n = myReminders(j).period
         s = trim$(str$(myReminders(j).date))
         yr = val(left$(s, 4)): mo = val(mid$(s, 5, 2)): day = val(right$(s, 2))        
         do                                                                                    
            mo = mo + n: IF mo > 12 THEN mo = n - 1: INCR yr
         loop until newDate(yr, mo, day) > valToday
         m = daysInMonth(mo, yr): if day > m then day = m
      elseif k = 4 then 'update to future week, same day                                     
         n = myReminders(j).period
         s = trim$(str$(myReminders(j).date))
         yr = val(left$(s, 4)): mo = val(mid$(s, 5, 2)): day = val(right$(s, 2))        
         do                               
            for i = 1 to n
               day = day + 7: m = daysInMonth(mo, yr)          
               if day > m then
                  incr mo: day = day - m
                  if mo > 12 then incr yr: mo = 1                    
               end if 
            next i  
         loop until newDate(yr, mo, day) > valToday     
      ELSEIF k = 5 THEN 'update to same weekday of future month 
         n = myReminders(j).period
         s = trim$(str$(myReminders(j).date))
         yr = val(left$(s, 4)): mo = val(mid$(s, 5, 2)): day = val(right$(s, 2))        
         do 
            i = dayOfWeek(mo, yr, day)                  
            ith = day \ 7 + SGN(day MOD 7)
            mo = mo + n: IF mo > 12 THEN mo = 1: INCR yr
            m = dayOfWeek(mo, yr, 1) '1st day of the month
            day = i - m + 1 + (ith - 1) * 7
            IF i < m THEN day = day + 7
         loop until newDate(yr, mo, day) > valToday   
      END IF
      remind = myReminders(j)                                                             
      s = RIGHT$("0" + TRIM$(STR$(mo)), 2) + RIGHT$("0" + TRIM$(STR$(day)), 2)
      remind.date = VAL(TRIM$(STR$(yr)) + s)
      k = remind.date
      n = 0               
      FOR i = 1 TO numReminders 'find insert position
         IF k < myReminders(i).date THEN n = i: EXIT FOR
      NEXT i
      if numReminders and n > 0 then                                         
         lastReminder = myReminders(numReminders)                           
         array insert myReminders(n), remind 'last reminder is lost here    
         incr numReminders: myReminders(numReminders) = lastReminder
      else                                                                       
         incr numReminders: myReminders(numReminders) = remind  
      end if      
   next j 
   for j = numUpdates to 1 step -1  'now delete first numUpdates      
      ARRAY DELETE myReminders(j): decr numReminders                      
   next j
END SUB

FUNCTION newDate(yr AS LONG, mo AS LONG, day AS LONG) AS LONG
   FUNCTION = yr * 10000 + mo * 100 + day
END FUNCTION

sub activateBtns(n as long)
   editing = 0
   if n = 0 then
      control disable hDlg, %ID_New
      control disable hDlg, %ID_Add
      control disable hDlg, %ID_Del
      control disable hDlg, %ID_Cancel
      control enable hDlg, %ID_Next
      control enable hDlg, %ID_Prev
   elseif n = 1 then 
      control enable hDlg, %ID_New
      control disable hDlg, %ID_Add
      control disable hDlg, %ID_Del
      control disable hDlg, %ID_Cancel
      control enable hDlg, %ID_Next
      control enable hDlg, %ID_Prev
   elseif n = 2 then
      editing = 1
      control set text hDlg, %ID_Add, "&Add"
      control disable hDlg, %ID_New           
      control enable hDlg, %ID_Add
      control disable hDlg, %ID_Del
      control enable hDlg, %ID_Cancel
      control disable hDlg, %ID_Next
      control disable hDlg, %ID_Prev 
   elseif n = 3 then
      editing = 2
      control set text hDlg, %ID_Add, "&Replace"
      control disable hDlg, %ID_New
      control enable hDlg, %ID_Add
      control enable hDlg, %ID_Del
      control enable hDlg, %ID_Cancel                          
      control disable hDlg, %ID_Next
      control disable hDlg, %ID_Prev
   elseif n = 4 then   
      control set text hDlg, %ID_Add, "&Replace"
      control enable hDlg, %ID_New
      control disable hDlg, %ID_Add
      control enable hDlg, %ID_Del
      control disable hDlg, %ID_Cancel
      control enable hDlg, %ID_Next
      control enable hDlg, %ID_Prev
   end if
   if reminderNo = 1 then control disable hDlg, %ID_Prev
   if reminderNo = numReminders then control disable hDlg, %ID_Next
end sub

sub MultReminders()
   local i, j, j0, beginDate, mult as long
   reset multReminds()
   j0 = 1
   for j = 1 to numReminders + 1
      if myReminders(j).Date <> beginDate then 'different date
         for i = j0 to j - 1
            if mult then multReminds(i) = i - j0 + 1
         next i
         j0 = j: beginDate = myReminders(j).date: mult = 0
      else 'same date
         mult = 1
      end if
   next j
end sub
                
SUB printReminders
   LOCAL m, n, i, y, x0, y0, nCount, linesPerPg, hPrn, mo, day, yr, num AS LONG
   LOCAL hPrnDC, hFont, hOrigFont, fontHt, xdpi, ydpi, leftDeadZone, topDeadZone AS LONG
   LOCAL beginNewPage, prnError AS BYTE, charHt, leftMargin AS DOUBLE                       
   LOCAL s, ss, t, weekDay AS STRING
   local tm AS TEXTMETRIC, di AS DOCINFO
   hPrnDC = choosePrinter(0)
   IF hPrnDC = 0 THEN EXIT SUB
   s = "winPam Print"                                   
   di.cbSize = SIZEOF(di)
   di.lpszDocName = VARPTR(s)
   fontHt = 11
   fontType = "MS Sans Serif"
   hFont = makeFont(hPrnDC, fontType, fontHt)
   hOrigFont = SelectObject (hPrnDC, hFont)
   getTextMetrics hPrnDC, tm
   charHt = tm.tmHeight + tm.tmExternalLeading
   xdpi = GetDeviceCaps (hPrnDC, %LOGPIXELSX) 'x direction dpi
   ydpi = GetDeviceCaps (hPrnDC, %LOGPIXELSY) 'y direction dpi
   leftDeadZone = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETX)   'dead zone at left
   topDeadZone = GetDeviceCaps (hPrnDC, %PHYSICALOFFSETY)    'dead zone on top
   linesPerPg = 9.75*ydpi\charHt: leftMargin = 0.75
   x0 = leftMargin * xdpi - leftDeadZone
   y0 = .500 * ydpi - topDeadZone
   IF StartDoc(hPrnDC, di) <= 0 THEN prnError = 2: GOTO WrapUp
   beginNewPage = 1
   if archiveMode = 0 then num = numReminders else num = numArchives
   FOR i = 1 TO num
      IF beginNewPage THEN
         nCount = 0: beginNewPage = 0
         IF StartPage(hPrnDC) <= 0 THEN prnError = 3: GOTO WrapUp
         printText hPrnDC, "Date", x0 + .12*xdpi, y0
         printText hPrnDC, "Day", x0 + 1.00*xdpi, y0
         printText hPrnDC, "Time", x0 + 1.55*xdpi, y0
         printText hPrnDC, "Event", x0 + 2.35*xdpi, y0
         printText hPrnDC, "Description", x0 + 4.00*xdpi, y0
         printText hPrnDC, "Notify", x0 + 6.75*xdpi, y0
      END IF
      if archiveMode = 0 then
         y = y0 + charHt * (nCount + 2)
         s = TRIM$(STR$(myReminders(i).date))
         s = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + LEFT$(s, 4)
         mo = val(left$(s, 2)): day = val(mid$(s, 4, 2)): yr = val(right$(s, 4))
         weekDay = MID$(daysInWeek, 4 * dayOfWeek(mo, yr, day) + 1, 3)
         printText hPrnDC, s, x0, y 'date
         n = myReminders(i).date: m = 0: t = ""
         IF myReminders(i).nEvent > 2 THEN m = myReminders(i).time
         IF m >= 1200 THEN ss = " pm" ELSE ss = " am"
         IF m >= 1300 THEN
            m = m - 1200
         ELSEIF m AND m <= 100 THEN
            m = 1200 + m
         END IF
         t = weekDay
         printText hPrnDC, t, x0 + 1.00*xdpi, y 'day
         IF m THEN t = FORMAT$(m\100, "##") + ":" + FORMAT$(m MOD 100, "00") + ss
         printText hPrnDC, t, x0 + 1.50*xdpi, y 'time
         printText hPrnDC, nEvents(myReminders(i).nEvent), x0 + 2.30*xdpi, y 'event
         s = myReminders(i).descr
         printText hPrnDC, truncateStr(hPrnDC, s, 4.20*xdpi), x0 + 3.45*xdpi, y 'descr
         s = STR$(myReminders(i).adv)
         printText hPrnDC, s, x0 + 7.00*xdpi - stringSize(hPrnDC, s), y 'notify
      else 'archive mode
         y = y0 + charHt * (nCount + 2)
         s = TRIM$(STR$(remindersArch(i).date))
         s = MID$(s, 5, 2) + "/" + RIGHT$(s, 2) + "/" + LEFT$(s, 4)
         mo = val(left$(s, 2)): day = val(mid$(s, 4, 2)): yr = val(right$(s, 4))
         weekDay = MID$(daysInWeek, 4 * dayOfWeek(mo, yr, day) + 1, 3)
         printText hPrnDC, s, x0, y 'date
         n = remindersArch(i).date: m = 0: t = ""
         IF remindersArch(i).nEvent > 2 THEN m = remindersArch(i).time
         IF m >= 1200 THEN ss = " pm" ELSE ss = " am"
         IF m >= 1300 THEN
            m = m - 1200
         ELSEIF m AND m < 100 THEN
            m = 1200 + m
         END IF
         t = weekDay
         printText hPrnDC, t, x0 + 1.00*xdpi, y 'day
         IF m THEN t = FORMAT$(m\100, "##") + ":" + FORMAT$(m MOD 100, "00") + ss
         printText hPrnDC, t, x0 + 1.50*xdpi, y 'time
         printText hPrnDC, nEvents(remindersArch(i).nEvent), x0 + 2.30*xdpi, y 'event
         s = remindersArch(i).descr
         printText hPrnDC, truncateStr(hPrnDC, s, 4.20*xdpi), x0 + 3.45*xdpi, y 'descr
         s = STR$(remindersArch(i).adv)
         printText hPrnDC, s, x0 + 7.00*xdpi - stringSize(hPrnDC, s), y 'notify
      end if   
      INCR nCount
      IF nCount > linesPerPg THEN
         EndPage hPrnDC: beginNewPage = 1
      END IF
   NEXT i
   EndPage hPrnDC
   EndDoc hPrnDC
WrapUp:                                                                 
   IF prnError THEN
      s = "Printing error has occurred"
      MSGBOX s, %MB_ICONERROR, "Printing Error" + STR$(prnError)
   END IF
   SelectObject hPrnDC, hOrigFont
   DeleteObject hFont
   DeleteDC hPrnDC
END SUB

FUNCTION MakeFont(hDC AS LONG, fontName AS STRING, BYVAL fontSize AS LONG, _
                                    OPT BYVAL fontAttr AS STRING) AS LONG
   'specify descr = b for bold, u for underline, i for italic
   LOCAL CyPixels, charHt AS LONG
   LOCAL wt, BOLD, underline, italic AS DWORD
   IF LEN(fontAttr) THEN
      BOLD = INSTR(fontAttr, "b") + 300
      underline = INSTR(fontAttr,"u")
      italic = INSTR(fontAttr,"i")
   END IF
   CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
   charHt = (fontSize * CyPixels) \ 72
   wt = %FW_NORMAL + BOLD
   FUNCTION = CreateFont(-charHt, 0, 0, 0, wt, italic, underline, 0, _
              %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
              %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY fontName)
END FUNCTION

SUB printText(BYVAL hPrnDC AS LONG, s AS STRING, x AS LONG, y AS LONG, _
                    OPT BYVAL fontSize AS LONG, BYVAL fontAttr AS STRING)
   LOCAL hFont, hOrigFont AS LONG
   IF fontSize THEN
      hFont = makeFont(hPrnDC, fontType, fontSize, fontAttr)
      hOrigFont = SelectObject (BYVAL hPrnDC, BYVAL hFont)
   END IF
   TextOut BYVAL hPrnDC, x, y, BYCOPY s, LEN(s)
   IF hFont THEN DeleteObject SelectObject(BYVAL hPrnDC, BYVAL hOrigFont)
END SUB

FUNCTION choosePrinter(landscape AS LONG) AS LONG
   'choose printer and return device context handle
   LOCAL n, hdc, hDevMode AS LONG
   LOCAL pDevMode AS DEVMODE PTR
   LOCAL pd AS PRINTDLGAPI, pDevNames AS DEVNAMES PTR
   LOCAL tm AS TEXTMETRIC, psz AS ASCIIZ PTR
   pd.lStructSize = SIZEOF(pd)
   pd.Flags = %PD_RETURNDC OR %PD_HIDEPRINTTOFILE
   pd.Flags = pd.Flags OR %PD_ALLPAGES OR %PD_NOSELECTION OR %PD_NOPAGENUMS
   IF PrintDlg(pd) THEN 'call print dialog to select printer
      pDevNames = GlobalLock(pd.hDevNames)
      psz = pDevNames + @pDevNames.wDeviceOffset
      GlobalUnlock pd.hDevnames: hdc = pd.hDC
   END IF
   hDevMode = pd.hDevMode
   n = landscape + 1
   IF hDevMode THEN
      pDevMode = GlobalLock(hDevMode)
      IF n AND @pDevMode.dmFields AND %DM_ORIENTATION THEN
         IF n THEN @pDevMode.dmOrientation = n
         @pDevMode.dmFields = @pDevMode.dmFields OR %DM_ORIENTATION
         ResetDC hdc, @pDevMode
         GlobalUnlock hDevMode
      END IF
   END IF
   FUNCTION = hdc
END FUNCTION
                                                                    
'-----------------------------------------------------------------------
' calendar routines
'-----------------------------------------------------------------------
SUB initCalendar
   LOCAL hdc, hFont, hOrigFont, i, n AS LONG
   local ti as string
   hdc = GetDC(hDlg)
'   hFont = makeFont(hDC, "MS Sans Serif", 10)
   hFont = makeFont(hDC, "Courier New", 9)
   hOrigFont = SelectObject(hdc, hFont)
   ti = "Sun Mon Tue Wed Thu Fri Sat"
   FOR i = 0 TO 1
      n = 220 * i
      SetTextColor hdc, %BLACK
      SetBkColor hdc, %WHITE
      showText hdc, 15 + n, 40, ti
      MoveToEx hDC, 10 + n, 60, BYVAL %NULL
      LineTo hDC, 210 + n, 60
      IF i = 0 THEN 'draw vert line
         MoveToEx hDC, 220 + n, 20, BYVAL %NULL
         LineTo hDC, 220 + n, 212                            
      END IF                                  
   NEXT i
   MoveToEx hDC, 10, 220, BYVAL %NULL
   LineTo hDC, 430, 220
   DeleteObject SelectObject(hdc, hOrigFont)
   ReleaseDC hDlg, hdc
END SUB 

sub clearMonths
   'clear calendar months displayed so that new months can be drawn
   '-----------------------------------------------------------------
   local i, j, x, y, hdc, hFont as long
   local clrLine as string
   clrLine = space$(27)
   hdc = GetDC(hDlg)
   hFont = makeFont(hdc, "Courier New", 10)
   SelectObject hdc, hFont
   for i = 0 to 1                
      x = 220 * i + 2: y = 70
      for j = 1 to 13 'require 11 lines to clear today bitmap
         y = 12 * j + 45                                          
         showText hDC, x, y, clrLine          
      next j
   next i
end sub                                    

sub calendarPos(sDate as string)                    
   'find calendar day matching sDate and draw square border around it
   '------------------------------------------------------------------ 
   local m, n, j, mo, day, yr, mo0, yr0, numDays, startDay as long
   mo = val(parse$(sDate, any "-/", 1))                                             
   day = val(parse$(sDate, any "-/", 2))                                          
   yr = val(parse$(sDate, any "-/", 3))
   mo0 = mo: yr0 = yr
   if (mo mod 2) <> (thisMo mod 2) then decr mo
   if mo < 0 then mo = 12: decr yr
   clearMonths
   showMonths mo, yr
   n = dayOfWeek(mo0, yr0, day)
   xMouse = 15 + 29*n + 1
   IF mo0 <> mo then xMouse = xMouse + 220
   numDays = daysInMonth(mo0, yr0)                                            
   startDay = dayOfWeek(mo0, yr0, 1)          
   n = 7 - startday                                                                 
   if day <= n then
      m = 1
   else                                             
      n = day-7+startDay: j = n\7                                          
      if n mod 7 then incr j
      m = j + 1
   end if                                                    
   yMouse = 45 + 25*m + 1
   showMonths mo, yr
end sub

SUB showMonths(BYVAL mo AS LONG, BYVAL yr AS LONG)        
   'display two calendar months with small square areas for each day
   'each day is then queried as follows
   '- red circle marking if it is today
   '- light gray background if day is a reminder
   '- square border date that is mouse clicked, or an added reminder
   '-----------------------------------------------------------------------------------------
   LOCAL hdc, hFont, hFont1, hOrigFont, memdc, hBit, thisDate, theDate, moSav, yrSav AS LONG
   LOCAL i, j, n, m, startDay, days, day, u, v, w, k, x, y, moYrLen, selected AS LONG
   LOCAL s, weekDay() AS STRING
   local t AS SIZEL, sz AS ASCIIZ * 128
   static x0, y0, j0, i0, mo0, yr0, theDate0, moSav0, yrSav0 as long
   static s0 as string
   DIM months(12) AS STRING
   months(1) = "January" : months(2) = "February" : months(3) = "March"
   months(4) = "April"   : months(5) = "May"      : months(6) = "June"
   months(7) = "July"    : months(8) = "August"   : months(9) = "September"
   months(10)= "October" : months(11)= "November" : months(12)= "December" 
   hdc = GetDC(hDlg)
   hBit = LoadBitmap(GetModuleHandle(BYVAL %NULL), "Today")
   hFont = makeFont(hdc, "Courier New", 10)
   hFont1 = makeFont(hdc, "MS Sans Serif", 12)
   SelectObject hdc, hFont1
   sz = SPACE$(42): GetTextExtentPoint32 hdc, sz, LEN(sz), t
   moYrLen = t.cx                                                               
   moSav = mo
   yrSav = yr
   FOR i = 0 TO 1         
      theDate = 10000 * yr + 100 * mo          
      SelectObject hdc, hFont1                      
      SetTextColor hdc, %WHITE                                          
      SetBkColor hdc, RGB(128, 128, 255)                        
      s = months(mo) + STR$(yr): sz = s                                     
      GetTextExtentPoint32 hdc, sz, LEN(sz), t                            
      showText hdc, 40 + 220*i, 10, SPACE$(36)
      showText hdc, INT((moYrLen - t.cx)/2) + 30 + 220*i, 10, s
      SelectObject hdc, hFont
      startDay = dayOfWeek(mo, yr, 1)   
      days = daysInMonth(mo, yr)
      m = 1: n = startDay
      FOR j = 1 TO days 
         s = RIGHT$(" " + STR$(j), 2)          
         x = 15 + 220*i + 29*n: y = 45 + 25*m
         SetTextColor hdc, %black: SetBkColor hdc, %white                                      
         IF xMouse > x AND xMouse < x + 29 AND yMouse > y AND yMouse < y + 25 THEN
            selected = 1 'clicked on this calenda day '-----------------------------------------,
            theDate = 10000 * yr + 100 * mo + j
            if (x <> x0 or y <> y0) and moSav = moSav0 and yrSav = yrSav0 then   
               'erase the last selection & redraw calendar --------------------------, 
               clearForm                                                        
               SetTextColor hdc, %black: SetBkColor hdc, %white
               showText hDC, x0-5, y0-5, space$(3)             
               showText hDC, x0-5, y0+5, space$(3)                                    
               showText hDC, x0, y0, s0
                                                                                          
               for k = 1 to numReminders 'light gray background
                  if myReminders(k).date = theDate0 then
                     SetTextColor hdc, %black: SetBkColor hdc, %RGB_lightgray                  
                     showText hDC, x0, y0, s0: exit for
                  end if                                                           
               next k                                   
               
               IF j0 = today AND mo0 = thisMo AND yr0 = thisYr THEN 'marking for today                                 
                  memdc = CreateCompatibleDC(hdc)                                 
                  SelectObject memdc, hBit
                  BitBlt hdc, x0-3, y0-3, 32, 32, memdc, 0, 0, %SRCAND                    
                  DeleteDC memdc
               end if
            end if '-----------------------------------------------------------------'                                                                         
            
            if nextPrev = 0 and dblclk = 0 and (editing = 0 or leftBtnDn = 1) then
               'for clicking in calendar, not Next/Prev, dblclk, or editing
               reminderNo = 0                                             
               for k = 1 to numReminders 'light gray background              
                  if myReminders(k).date = theDate then
                     reminderNo = k: fillForm(reminderNo): exit for
                  end if                                                        
               next k
               leftBtnDn = 0
            end if                                   
                                                                                  
            if nArrow = 0 then
               moveToEx hDC, x-3, y-2, BYVAL %NULL 'draw square around selected day                                      
               lineTo hDC, x+18, y-2                                                        
               lineTo hdc, x+18, y+18                                                       
               lineTo hdc, x-3, y+18
               lineTo hdc, x-3, y-2
               moSav0 = moSav: yrSav0 = yrSav: theDate0 = theDate
               x0 = x: y0 = y: s0 = s: j0 = j: i0 = i: mo0 = mo: yr0 = yr
               selMo = mo: selDay = j: selYr = yr 
               theDay = j 
               exit for: exit for
            end if
         END IF '-------------------------------------------------------------------------------'
          
         incr theDate  'show light gray day if a reminder 
         if j >= today or mo > thisMo or yr > thisYr then                                     
            for k = 1 to numReminders
               if myReminders(k).date = theDate then
                  SetTextColor hdc, %black: SetBkColor hdc, %RGB_lightgray
               end if                                                                              
            next k                                                               
         end if                                               
         
         showText hDC, x, y, s
         
         if listMode and j = j0 and i = i0 then
            moveToEx hDC, x-3, y-2, BYVAL %NULL 'draw square around selected day                                      
            lineTo hDC, x+18, y-2                                                   
            lineTo hdc, x+18, y+18                                                       
            lineTo hdc, x-3, y+18
            lineTo hdc, x-3, y-2
         end if 
         
         IF j = today AND mo = thisMo AND yr = thisYr THEN  'show today with red marking
            memdc = CreateCompatibleDC(hdc)
            SelectObject memdc, hBit
            BitBlt hdc, x-3, y-3, 32, 32, memdc, 0, 0, %SRCAND               
            DeleteDC memdc 
         END IF
         INCR n: IF n MOD 7 = 0 THEN INCR m: n = 0
      NEXT j
      INCR mo: IF mo > 12 THEN mo = 1: INCR yr
   NEXT i
   theMo = moSav: theYr = yrSav                                       
   statusbar set text hDlg, %ID_Status, 2, 0, ""
   statusbar set text hDlg, %ID_Status, 3, 0, ""      
   if reminderNo then 
      s = "  Reminder" + str$(reminderNo) + " of" + str$(numReminders) 
      statusbar set text hDlg, %ID_Status, 2, 0, s                        
      m = multReminds(reminderNo): if m then s = str$(m) else s = "   "
      statusbar set text hDlg, %ID_Status, 3, 0, s  
   end if
   if nArrow then                                        
      activateBtns 0                                  
   elseif formChanged then
      if reminderNo then activateBtns 3 else activateBtns 2   
   elseif reminderNo and editing = 0 and listMode = 0 then
      activateBtns 4                             
   elseif selected then 
      if reminderNo then activateBtns 4 else activateBtns 1                      
   end if      
   xMouse = 0: yMouse = 0: nArrow = 0        
   DeleteObject hBit                                                            
   DeleteObject SelectObject(hdc, hOrigFont)                                                     
   ReleaseDC hDlg, hdc 
END SUB

SUB showText(hDC AS LONG, x AS LONG, y AS LONG, sTxt AS STRING)
   TextOut hDC, x, y, BYVAL STRPTR(sTxt), LEN(sTxt)
END SUB

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS INTEGER
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN
      days = 28
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN INCR days 'leap yr
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION dayOfWeek(mo AS LONG, yr AS LONG, day AS LONG) AS LONG
   'Sun=0, Mon=1, Tue=2,... Sat=6
   if yr < 100 then yr = 2000 + yr                                                                  
   LOCAL n AS LONG
   n = yr - 1899 + (yr - 1901) \ 4 
   IF mo < 8 THEN
      n = n + 30 * (mo - 1) + mo \ 2
   ELSE
      n = n + 30 * (mo - 1) + (mo + 1) \ 2
   END IF 
   IF mo > 2 THEN
      n = n - 2
      IF (yr MOD 100 <> 0 OR yr MOD 400 = 0) _
         AND yr MOD 4 = 0 THEN IF mo > 2 THEN INCR n 'leap yr
   END IF
   FUNCTION = (n + day - 1) MOD 7
END FUNCTION

FUNCTION truncateStr(hdc AS LONG, s AS STRING, allowExt AS LONG) AS STRING
   LOCAL sTxt AS ASCIIZ*256, nLen AS LONG, nFit AS LONG, cSize AS SIZEL
   sTxt = s: nLen = LEN(sTxt)
   GetTextExtentExPoint hdc, BYVAL VARPTR(sTxt), nLen, allowExt, nFit, BYVAL %NULL, cSize
   FUNCTION = LEFT$(s, nFit)
END FUNCTION

FUNCTION stringSize(hdc AS LONG, s AS STRING) AS LONG
   LOCAL sTxt AS ASCIIZ*256, cSize AS SIZEL
   sTxt = s: GetTextExtentPoint32 hdc, sTxt, len(sTxt), cSize
   FUNCTION = cSize.cx
END FUNCTION

'-------------------------------------------------------------------------------------
'myInput by Charles Dietz  01-16-07, rev 07-08-12
'substitute for PowerBasic's Input routine
'-------------------------------------------------------------------------------------
FUNCTION myInput(OPT BYVAL hParent AS LONG, BYVAL prompt AS STRING, _
                     BYVAL ti AS STRING, BYVAL def AS STRING) AS STRING
   'def - default input string used to specify textbox size
   '      for 3 lines, use def = STRING$(60, 32) + $CRLF + $CRLF                           
   '-----------------------------------------------------------------------------
   LOCAL hInput, hdc, nStyle, hFont, numLines, ht, wi, w1, w2, w3, x, y AS LONG
   LOCAL t AS SIZEL, sz AS asciiZ * 256, s, myInputStr AS STRING
   nStyle = %WS_CAPTION OR %WS_POPUP OR %WS_SYSMENU OR %DS_MODALFRAME OR %WS_SYSMENU
   DIALOG NEW PIXELS, hParent, ti, , , 0, 0, nStyle TO hInput
   hdc = GetDC(hInput)
   DIALOG SEND hInput, %WM_GETFONT, 0, 0 TO hFont
   SelectObject(hdc, hFont)
   numLines = parsecount(def, $crlf)
   sz = prompt: GetTextExtentPoint32 hDC, sz, LEN(sz), t: w1 = t.cx
   sz = def + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w2 = MAX(t.cx, 130)
   sz = ti + SPACE$(2): GetTextExtentPoint32 hDC, sz, LEN(sz), t: w3 = MAX(t.cx, 150)
   wi = MAX(w1 + w2, w3, 150)
   'ht = 20 * numLines
   ht = t.cy * numLines + 10
   IF hParent THEN
      DIALOG GET CLIENT hParent TO x, y
   ELSE
      DESKTOP GET CLIENT TO x, y
   END IF
   x = x/2 - wi/2: y = y/4
   DIALOG SET LOC hInput, x, y
   DIALOG SET SIZE hInput, wi + 40, ht + 120
   CONTROL ADD LABEL, hInput, -1, prompt, 5, 15, w1 + 5, 20
   nStyle = 0: def = ""
   if numLines > 1 then nStyle = %ES_MULTILINE or %ES_WANTRETURN
   CONTROL ADD TEXTBOX, hInput, 9999, def, w1 + 5, 15, w2 + 5, ht, nStyle, %WS_EX_CLIENTEDGE
   IF LEN(def) THEN CONTROL SEND hInput, 9999, %EM_SETSEL, 0, -1
   CONTROL ADD BUTTON, hInput, %IDOK, "Ok", wi - 60, ht + 40, 80, 30
   DIALOG SET USER hInput, 1, VARPTR(myInputStr)
   DIALOG SHOW MODAL hInput, CALL myInputProc
   ReleaseDC hInput, hdc
   FUNCTION = myInputStr
END FUNCTION

FUNCTION exist(fname$) as DWORD
FUNCTION = Len( Dir$(fname$, 17) ) > 0
END FUNCTION
                                                                                
CALLBACK FUNCTION myInputProc()
   LOCAL ps AS STRING PTR
   SELECT CASE CB.MSG
      CASE %WM_INITDIALOG
         CONTROL SET FOCUS CB.HNDL, 9999
      CASE %WM_COMMAND                                            
         IF CBCTL = %IDOK OR CB.CTL = %IDCANCEL THEN
            DIALOG GET USER CB.HNDL, 1 TO ps
            CONTROL GET TEXT CB.HNDL, 9999 TO @ps 
            DIALOG END CB.HNDL
         END IF
      CASE %WM_SYSCOMMAND                                                   
         IF CB.CTL = %SC_CLOSE THEN
            DIALOG SEND CB.HNDL, %WM_COMMAND, %IDCANCEL, 0
         END IF
   END SELECT
END FUNCTION

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING                 
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION
