#COMPILE EXE
#DIM ALL                                     
#INCLUDE "wIN32api.inc"
#include "debug.inc"
                                   
'killProcess types
%TH32CS_SNAPPROCESS = &H2                                                                    
%MAX_MODULE_NAME32 = 255
TYPE PROCESSENTRY32
   dwSize               AS DWORD
   cntUsage             AS DWORD
   th32ProcessID        AS DWORD                              ' This process
   th32DefaultHeapID    AS LONG PTR
   th32ModuleID         AS DWORD                              ' Associated exe
   cntThreads           AS DWORD
   th32ParentProcessID  AS DWORD                              ' This process's parent process
   pcPriClassBase       AS LONG                               ' Base priority of process threads
   dwFlags              AS DWORD
   szExeFile            AS ASCIIZ * %MAX_PATH                 ' Path
END TYPE

TYPE MODULEENTRY32
   dwSize               AS DWORD
   th32ModuleID         AS DWORD                              ' This module
   th32ProcessID        AS DWORD                              ' Owning process
   GlblcntUsage         AS DWORD                              ' Global usage count on the module
   ProccntUsage         AS DWORD                              ' Module usage count in th32ProcessID's context
   modBaseAddr          AS BYTE PTR                           ' Base address of module in th32ProcessID's context
   modBaseSize          AS DWORD                              ' Size in bytes of module starting at modBaseAddr
   hModule              AS DWORD                              ' The hModule of this module in th32ProcessID's context
   szModule             AS ASCIIZ * (%MAX_MODULE_NAME32 + 1)
   szExePath            AS ASCIIZ * %MAX_PATH
END TYPE    

'create shortcut
DECLARE FUNCTION IShellLink_Call0(BYVAL pUnk AS LONG) AS LONG
DECLARE FUNCTION IShellLink_Call1(BYVAL pUnk AS LONG, BYVAL p1 AS LONG) AS LONG
DECLARE FUNCTION IShellLink_Call2(BYVAL pUnk AS LONG, BYVAL p1 AS LONG, BYVAL p2 AS LONG) AS LONG
DECLARE FUNCTION CoCreateInstance LIB "ole32.dll" ALIAS "CoCreateInstance" (rclsid AS GUIDAPI, _
        pUnkOuter AS ANY, BYVAL dwClsContext AS DWORD, riid AS GUIDAPI, ppv AS any) AS LONG  'DWORD
DECLARE SUB CoUninitialize LIB "ole32.dll" ALIAS "CoUninitialize"
DECLARE SUB CoTaskMemFree LIB "ole32.dll" ALIAS "CoTaskMemFree" (pv AS any)

'killProcess routines
DECLARE FUNCTION CreateToolhelp32Snapshot (BYVAL dwFlags AS DWORD, BYVAL th32ProcessID AS DWORD) AS LONG
DECLARE FUNCTION Process32First           (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Process32Next            (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Module32First            (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION Module32Next             (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION EnumProcesses            (idProcess AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG
DECLARE FUNCTION GetModuleFileNameEx      (BYVAL hProcess AS DWORD, BYVAL hModule AS DWORD, ModuleName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION EnumProcessModules       (BYVAL hProcess AS DWORD, hModule AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG

FUNCTION PBMAIN()
   'this program installs myReminders.exe 
   local n as long
   local dataFolder, progDataFolder, myDataFolder, exeFolder, s as string 
   
   if isfile("myReminders.ahp") = 0 or isfile("myReminders.exe") = 0 or isfile("myRemindersStartup.exe") = 0 then
      msgbox "The following files must be available" + $crlf _ 
           + "in the same folder as this program:" + $crlf + $crlf _
           + $tab + "myReminders.ahp" + $crlf _
           + $tab + "myReminders.exe" + $crlf _ 
           + $tab + "myRemindersStartup.exe", %mb_iconinformation, "Required Files"
      exit function                                                           
   end if                 

   msgbox "copying file now... please wait": 
   filecopy "myReminders.rmd", dataFolder + "\myReminders.rmd"     
   progDataFolder = specialFolder(%CSIDL_COMMON_APPDATA) '===== ProgramData folder
   if isFolder(progDataFolder + "\cgdSoftware\myReminders") = 0 then
      mkdir progDataFolder + "\cgdSoftware"
      mkdir progDataFolder + "\cgdSoftware\myReminders\"             
   end if 
   progDataFolder = progDataFolder + "\cgdSoftware\myReminders"
   filecopy "myReminders.ahp", progDataFolder + "\myReminders.ahp"
       
   myDataFolder = specialFolder(%CSIDL_PERSONAL) '===== chuck\documents         
   if isFolder(myDataFolder + "\cgdSoftware\myReminders") = 0 then                     
      mkdir myDataFolder + "\cgdSoftware\"
      mkdir myDataFolder + "\cgdSoftware\myReminders"             
   end if
   myDataFolder = myDataFolder + "\cgdSoftware\myReminders"
   if isfile("myReminders.rmd") then 'incase the dataFile is included
      filecopy "myReminders.rmd", myDataFolder + "\myReminders.rmd" 
   end if                       
   
   exeFolder = specialFolder(%CSIDL_PROGRAM_FILESX86) '===== Program Files(x86)
   if isFolder(exeFolder + "\cgdSoftware\myReminders") = 0 then
      mkdir exeFolder + "\cgdSoftware\"
      mkdir exeFolder + "\cgdSoftware\myReminders"             
   end if
   exeFolder = exeFolder + "\cgdSoftware\myReminders"
   filecopy "myReminders.exe", exeFolder + "\myReminders.exe"     
   filecopy "myRemindersStartup.exe", exeFolder + "\myRemindersStartup.exe"
   
   'create shortcut to myRemindersStartup.exe in startup folder                                                                       
   chdir exeFolder                                                            
   s = curdir$ + "\myReminders.exe"                                             
   createShortcut %CSIDL_DESKTOP, "myReminders.lnk", s, curdir$                                    
   killProcess "myRemindersStartup.exe"
   s = curdir$ + "\myRemindersStartup.exe"                                             
   createShortcut %CSIDL_STARTUP, "myRemindersStart.lnk", s, curdir$
   
   'finally, reboot the computer
   s = "myReminders setup completed... restart Windows now?"           
   n = MSGBOX(s, %MB_YESNO OR %MB_ICONWARNING, "Confirm Windows Restart")
   if n = %idno then exit function
   IF IsNT() THEN
      IF ISFALSE AdjustToken() THEN
         MSGBOX "Could not obtain shutdown privilege.": EXIT FUNCTION
      END IF                                                                                              
   END IF
   IF ISFALSE ExitWindowsEx(%EWX_REBOOT OR %EWX_SHUTDOWN, 0) THEN 
      MSGBOX "Shutdown failed."
   END IF
eND FUNCTION                                          

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'----------------------------------------------------------------------
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
end function

FUNCTION createShortcut(CSIDL AS DWORD, link AS STRING, SOURCE AS STRING, workDir AS STRING) AS LONG
    'adapted from Edwin Knoppert's code 07-10-03
    'http://www.powerbasic.com/support/forums/Forum7/HTML/001980.html
    'CSIDL   - CSIDL_DESKTOP, CSIDL_PROGRAMS, CSIDL_STARTUP, etc                            
    'link    - link file to be created like "My calc.lnk"
    'source  - file/document where the shortcut should point to like "c:\windows\calc.exe".
    'workDir - folder where the executable document/file should start in, best not to leave empty.
    '===============================================================================================
    LOCAL CLSID_ShellLink AS STRING * 16
    LOCAL IID_IShellLink  AS STRING * 16
    LOCAL IID_Persist     AS STRING * 16
    LOCAL nResult AS LONG, pShellLnk AS DWORD PTR, pPersist AS DWORD PTR
    LOCAL sLink AS STRING, szUniLnkName AS ASCIIZ * (2 * %MAX_PATH)
    LOCAL sArguments AS STRING, sComment AS STRING

    CLSID_ShellLink = MKL$(&H00021401) & CHR$(0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46)
    IID_IShellLink  = MKL$(&H000214EE) & CHR$(0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46)
    IID_Persist     = MKL$(&H0000010B) & CHR$(0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46)
    sArguments = "": sComment = ""
    CoInitialize BYVAL 0&                                       

    IF CoCreateInstance(BYVAL VARPTR(CLSID_ShellLink), BYVAL 0&, 1, BYVAL VARPTR(IID_IShellLink), pShellLnk) = 0 THEN
        '// IShellLink::SetPath
        CALL DWORD @@pShellLnk[20] USING IShellLink_Call1(pShellLnk, STRPTR(SOURCE))
        '// IShellLink::SetsArguments
        CALL DWORD @@pShellLnk[11] USING IShellLink_Call1(pShellLnk, STRPTR(sArguments))
        '// IShellLink::SetWorkingDirectory
        CALL DWORD @@pShellLnk[9] USING IShellLink_Call1(pShellLnk, STRPTR(workDir))
        '// IShellLink::SetnShowCmd
        CALL DWORD @@pShellLnk[15] USING IShellLink_Call1(pShellLnk, %SW_SHOW)
        '// IShellLink::SetDescription
        CALL DWORD @@pShellLnk[7] USING IShellLink_Call1(pShellLnk, STRPTR(sComment))
        '// Obtain persist interface (QueryInterface)
        CALL DWORD @@pShellLnk[0] USING IShellLink_Call2(pShellLnk, VARPTR(IID_Persist), VARPTR(pPersist))

        IF nResult = %S_OK THEN
            '// Convert to unicode
            sLink = SpecialFolder(CSIDL) + "\" + link
            MultiByteToWideChar %CP_ACP, 0, BYVAL STRPTR(sLink), LEN(sLink), BYVAL VARPTR(szUniLnkName), %MAX_PATH * 2
            '// IPersistFile::Save
            CALL DWORD @@pPersist[6] USING IShellLink_Call2(pPersist, VARPTR(szUniLnkName), 1)
            '// Release
            CALL DWORD @@pPersist[2] USING IShellLink_Call0(pPersist)
        END IF
         '// Release
        CALL DWORD @@pShellLnk[2] USING IShellLink_Call0(pShellLnk)
        FUNCTION = -1
    END IF
    CoUninitialize
END FUNCTION

SUB killProcess(progName AS STRING)
   'Enumerate Processes by Semen Matusovski
   'http://www.powerbasic.com/support/forums/Forum7/HTML/001497.html (08-03-2002)
   '=======================================================================================
   LOCAL hKernel32, hCreateToolhelp32Snapshot, hProcess32Next, hProcess32First AS DWORD
   LOCAL hModule32First, hModule32Next, hPsApiDll, hEnumProcesses, hProcessSnap AS DWORD
   LOCAL hGetModuleFileNameEx, hEnumProcessModules, nModules, cb, cbNeeded, i AS DWORD
   LOCAL nProcesses, hProcess, procID AS DWORD, lResult1 AS LONG, processName AS STRING
   LOCAL os AS OSVERSIONINFO, pe AS PROCESSENTRY32

   processName = LCASE$(progName)
   os.dwOSVersionInfoSize = SIZEOF(os)      
   GetVersionEx BYVAL VARPTR(os)

   IF ISFALSE(os.dwPlatformId = %VER_PLATFORM_WIN32_NT) THEN 'Windows 95/98
      hKernel32                 = GetModuleHandle("kernel32.dll")
      hCreateToolhelp32Snapshot = GetProcAddress(hKernel32, "CreateToolhelp32Snapshot")
      hProcess32Next            = GetProcAddress(hKernel32, "Process32Next")
      hProcess32First           = GetProcAddress(hKernel32, "Process32First")
      hModule32First            = GetProcAddress(hKernel32, "Module32First")
      hModule32Next             = GetProcAddress(hKernel32, "Module32Next")

      CALL DWORD hCreateToolhelp32Snapshot USING CreateToolhelp32Snapshot (%TH32CS_SNAPPROCESS, 0&) TO hProcessSnap
      IF hProcessSnap <> %INVALID_HANDLE_VALUE THEN
         pe.dwSize = SIZEOF(pe)
         CALL DWORD hProcess32First USING Process32First (hProcessSnap, pe) TO lResult1
         DO WHILE lResult1
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = pe.th32ProcessID: EXIT DO
            END IF
            CALL DWORD hProcess32Next USING Process32Next (hProcessSnap, pe) TO lResult1
         LOOP
         CloseHandle hProcessSnap
     END IF
                                                
   ELSE ' Windows NT
      hPsApiDll = GetModuleHandle("psApi.dll"): IF hPsApiDll = 0 THEN hPsApiDll = LoadLibrary("psApi.dll")
      hEnumProcesses       = GetProcAddress(hPsApiDll, "EnumProcesses")
      hGetModuleFileNameEx = GetProcAddress(hPsApiDll, "GetModuleFileNameExA")
      hEnumProcessModules  = GetProcAddress(hPsApiDll, "EnumProcessModules")

      cb = 100
      DO
         REDIM ProcessIDs(1 TO cb \ 4) AS DWORD
         CALL DWORD hEnumProcesses USING EnumProcesses (ProcessIDs(1), cb, cbNeeded) TO lResult1
         IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
      LOOP
      nProcesses = cbNeeded \ 4
      FOR i = 1 TO nProcesses
         hProcess = OpenProcess(%PROCESS_QUERY_INFORMATION OR %PROCESS_VM_READ, %False, ProcessIDs(i))
         IF hProcess THEN
            cb = 100
            DO
               REDIM Modules(1 TO cb / 4) AS DWORD
               CALL DWORD hEnumProcessModules USING EnumProcessModules (hProcess, Modules(1), cb, cbNeeded) TO lResult1
               IF lResult1 = 0 THEN cbNeeded = 0: ITERATE FOR
               IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
            LOOP
            nModules = cbNeeded / 4
            CALL DWORD hGetModuleFileNameEx USING GetModuleFileNameEx (hProcess, Modules(1), pe.szExeFile, SIZEOF(pe.szExeFile)) TO lResult1
            CloseHandle hProcess
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = ProcessIDs(i): EXIT FOR
            END IF
         END IF
      NEXT
   END IF
   hProcess = OpenProcess(%PROCESS_TERMINATE, %false, procID)
   IF hProcess THEN
      TerminateProcess hProcess, 0
      Closehandle hProcess
   END IF
END SUB
   
'--------------------------------------------------------------------------
'routines for shutdown and restart from PowerBasic Samples, util    
'--------------------------------------------------------------------------
FUNCTION IsNt () AS LONG
    LOCAL tOsVersion AS OSVERSIONINFO
    tOsVersion.dwOSVersionInfoSize = SIZEOF(tOsVersion)
    IF GetVersionEx(tOsVersion) THEN
        FUNCTION = (tOsVersion.dwPlatformId = %VER_PLATFORM_WIN32_NT)
    END IF
END FUNCTION

FUNCTION AdjustToken () AS LONG                          
    LOCAL hToken       AS DWORD
    LOCAL tokenProcess AS TOKEN_PRIVILEGES
    'get the privilege token for this process.
    IF ISFALSE OpenProcessToken(GetCurrentProcess(), _
               %TOKEN_ADJUST_PRIVILEGES OR %TOKEN_QUERY, hToken) THEN
        EXIT FUNCTION
    END IF
    'get the value of the shutdown privilege.
    IF LookupPrivilegeValue(BYVAL %NULL, "SeShutdownPrivilege", _
               tokenProcess.Privileges(0).Luid) THEN
        ' Enable the shutdown privilege for this process.
        tokenProcess.PrivilegeCount           = 1
        tokenProcess.Privileges(0).Attributes = %SE_PRIVILEGE_ENABLED
        FUNCTION = AdjustTokenPrivileges(hToken, %FALSE, BYVAL VARPTR(tokenProcess), 0, _
                   BYVAL %NULL, BYVAL %NULL)
    END IF
    CloseHandle hToken
END FUNCTION

