#COMPILE EXE                                                                                   
#DIM ALL
'#debug display on                                 
#INCLUDE "win32api.inc"
'#INCLUDE "debug.inc"                                                
                                                     
$version = "1.00" 
$RemindFile = "myReminders.rmd"                              
%ID_Acknowledge = 101
 
TYPE reminderType
   nEvent AS BYTE               'event (birthday, anniversary, appointment, meeting, other)
   descr AS STRING *48          'description of event (Dr Smith, orthopedic)
   date AS LONG                 'next date for event - enter(10-13-2000)
   time AS INTEGER              'military time or year of birthday/anniversary
   adv AS BYTE                  'notify days in advance (255 max)
   period AS BYTE               'number of weeks or months per period
   freq AS BYTE                 'oneTime = 1, annual = 2, period of months = 3
                                'period of weeks = 4, weekday period of months = 5
end type
                                   
GLOBAL hRemind, numReminders, reminderNo, numArchives, exitRemind, hdc AS LONG            
GLOBAL myReminders() AS reminderType
global remindersArch() as reminderType
GLOBAL dataFile AS STRING                        
GLOBAL nEvents() AS STRING
                                 
FUNCTION PBMAIN() AS LONG                                 
   LOCAL hMain, hMutex, nLen AS LONG
   LOCAL months, daysOfWeek, weekNo AS STRING
   LOCAL dataFolder AS STRING
   dim myReminders(1 to 200)
   dim remindersArch(1 to 200) 
   dim nEvents(1 to 5)
   nEvents(1) = "birthday"
   nEvents(2) = "anniversary"           
   nEvents(3) = "reminder"
   nEvents(4) = "appointment"                           
   nEvents(5) = "Meeting"                                       
   DIALOG FONT "arial", 10
   dataFolder = specialFolder(%CSIDL_PERSONAL)  'c:\users\chuck\documents\
   dataFolder = dataFolder + "\cgdSoftware\myReminders\"
   IF ISFOLDER(dataFolder) = 0 THEN dataFolder = exe.path$                  
   DataFile = dataFolder + $RemindFile 
   '-----------------------------------------------------------------------------------------------------
   months = "January February March April May June July August September October November December"
   daysOfWeek = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday"
   weekNo = "First Second Third Fourth"                                    
   IF alreadyRunning(hMutex, "myRemindersStartup") then
      MSGBOX "myRemindersStartup is already loaded", %MB_iconerror, " "
      EXIT FUNCTION
   END IF
   DIALOG NEW 0, "Reminders", , , 0, 0 TO hMain         
   DIALOG SHOW STATE hMain, %SW_HIDE                            
   DIALOG SHOW MODAL hMain CALL mainProc
END FUNCTION

CALLBACK FUNCTION mainProc()
   LOCAL time, today, numUpdates, numArchives, numArchs, num AS LONG
   local j, k, m, n, mo, day, yr, valLastMo, valToday as long
   STATIC showing AS LONG
   STATIC s AS STRING              
   SELECT CASE CBMSG                 
      CASE %WM_INITDIALOG
         do
            '---------------------------------------------------------------------
            ' if beginning of a new day and reminders are not already showing,
            ' then show reminders, reset timer, and repeat again tomorrow             
            '---------------------------------------------------------------------
            IF showing THEN 'close reminders if being show
               DIALOG SEND hRemind, %WM_SYSCOMMAND, %SC_CLOSE, 0: exitRemind = 0: showing = 0
            END IF
 
            openReminders
            
            '-------------------------------------------------------                     
            ' let's keep one month of archives
            '-------------------------------------------------------
            valToday = VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))
            mo = val(left$(date$, 2)): yr = val(RIGHT$(DATE$, 4)) 
            decr mo: if mo < 1 then mo = 12: decr yr
            valLastMo = VAL(trim$(str$(yr)) + trim$(str$(mo)) + MID$(DATE$, 4, 2))
            for j = numArchives to 1 step -1 
               if remindersArch(j).date < valLastMo then                            
                  array delete remindersArch(j): decr numArchs
               end if
            next j
            n = numArchives                                                                                 
            for j = 1 to numReminders
               if myReminders(j).date >= valToday then exit for 'don't archive for today or after
               if myReminders(j).nEvent < 3 then iterate 'don't archive birtdays or anniversaries
               if myReminders(j).freq > 1 then iterate 'don't archive repeating events
               remindersArch(n + j) = myReminders(j): incr numArchs
            next j
            saveReminders()
            
            '-------------------------------------------------------                     
            ' next, update all reminders before today (past due)
            '-------------------------------------------------------
            valToday = VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))
            num = numReminders                                                    
            for j = 1 to num
               if myReminders(j).date >= valToday then exit for
               updateReminder(j): incr numUpdates             
            next j
            for j = numUpdates to 1 step -1  'now delete updated reminders
               ARRAY DELETE myReminders(j): decr numReminders
            next j
             
            '----------------------------------------------                    
            ' finally, show all reminders that are due 
            '---------------------------------------------- 
            for j = 1 to numReminders
               n = myReminders(j).date
               mo = val(left$(date$, 2)): day = val(MID$(DATE$, 4, 2)): yr = val(right$(date$, 4))
               m = daysInMonth(mo, yr)
               k = myReminders(j).adv
               if day + k > m then 
                  incr mo: day = k - (m - day)                                  
                  if mo > 12 then incr yr: mo = 1
               else                                    
                  day = day + k   
               end if
               k = newDate(yr, mo, day)
               if k >= n then                                  
                  showing = 1
                  showReminder(j)
                  if exitRemind then exit for
               end if                        
            next j
            for j = numReminders to 1 step -1
               if myReminders(j).date < 0 then
                  'myReminders(j).date = abs(myReminders(j).date)
                  array delete myReminders(j): decr numReminders
               end if 
            next i   
            saveReminders()
            waitableTimer
         loop
   end select      
END FUNCTION

FUNCTION alreadyRunning(hMutex AS LONG, mutexName AS ASCIIZ *64) AS LONG
   'check if instance of program is already running
   'Returns: 1  already running
   '         0  first instance                                                   
   hMutex = CreateMutex (BYVAL %NULL, %FALSE, BYVAL VARPTR(mutexName))
   IF hMutex THEN 'got a handle, but was it already existing?
      IF GetLastError = %Error_Already_Exists THEN FUNCTION = 1
   END IF
END FUNCTION
                                                                                                                    
FUNCTION getSleepTime() AS LONG
   'compute seconds until 12am tomorrow with a good measure of 60 secs
   local n, n1, n2, n3, goodMeasure AS LONG
   LOCAL s AS STRING
   s = TIME$: goodMeasure = 10: n1 = VAL(PARSE$(s, ":", 1))
   n2 = VAL(PARSE$(s, ":", 2)): n3 = VAL(PARSE$(s, ":", 3))
   n = (24 - n1 - 1) * 3600 + (60 - n2) * 60 + n3 + goodMeasure
'   n = 5 'program development 
   function = n
END FUNCTION                                                
                        
SUB waitableTimer()
   LOCAL tq AS QUAD                                                                        
   LOCAL n AS LONG                    
   LOCAL htimer AS DWORD
   'waitable timer: time in 100 nanosecond intervals (neg for relative time)
   htimer = CreateWaitableTimer(byval %NULL, 1, byval %NULL)
   IF htimer THEN
      tq = -10000000 * getSleeptime
      SetWaitableTimer htimer, tq, 0, %NULL, %NULL, 1
      WaitForSingleObject htimer, %INFINITE
      CloseHandle htimer
   END IF                                                                         
END SUB                                                              

sub openReminders
   LOCAL i, fileNum AS LONG                      
   LOCAL ver AS STRING                             
   fileNum = FREEFILE
   OPEN dataFile FOR BINARY AS fileNum                       
   ver = $version                                                               
   get #fileNum,, ver
   get #fileNum,, numReminders
   FOR i = 1 TO numReminders
      get #fileNum,, myReminders(i)
   NEXT i
   get #fileNum,, numArchives
   FOR i = 1 TO numArchives
      get #fileNum,, remindersArch(i)
   NEXT i
   CLOSE #fileNum
end sub

SUB saveReminders()
   LOCAL fileNum, i AS LONG
   local ver AS STRING
   local b AS BYTE
   KILL dataFile
   fileNum = FREEFILE
   OPEN dataFile FOR BINARY AS fileNum
   ver = $version                                                                                       
   PUT #fileNum,, ver                                                                                      
   PUT #fileNum,, numReminders
   FOR i = 1 TO numReminders
      PUT #fileNum,, myReminders(i)
   NEXT i
   put #fileNum,, numArchives
   FOR i = 1 TO numArchives
      put #fileNum,, remindersArch(i)
   NEXT i
   CLOSE #fileNum                                
END SUB

SUB showReminder(i as long)
   local nStyle as long
   if myReminders(i).freq < 0 then exit sub
   nStyle = %WS_CAPTION OR %DS_MODALFRAME OR %WS_SYSMENU OR %WS_MINIMIZEBOX 
   DIALOG NEW PIXELS, 0, " myReminders", , , 400, 220, nStyle TO hRemind
   CONTROL ADD BUTTON, hRemind, %IDOK, "&Remind Again", 240, 150, 100, 40, %WS_TABSTOP + %BS_DEFAULT
   CONTROL ADD BUTTON, hRemind, %ID_Acknowledge, "&Acknowledge", 40, 150, 100, 40, %WS_TABSTOP
   dialog set user hRemind, 1, i
   DIALOG SHOW MODAL hRemind CALL showRemindersProc
END SUB

CALLBACK FUNCTION showRemindersProc                                                     
   LOCAL n, m, k, nth, mo, day, yr, reminderDate AS LONG
   LOCAL months, daysOfWeek, weekNo AS STRING 
   STATIC i, hBrush, bkgdColor AS LONG
   static s, s1, s2, s3, s4 AS STRING                                
   SELECT CASE CBMSG
      CASE %WM_INITDIALOG 
         dialog get user cb.hndl, 1 to i  'show reminder i
         months = "January February March April May June July August September October November December"
         daysOfWeek = "Sunday Monday Tuesday Wednesday Thursday Friday Saturday"
         weekNo = "First Second Third Fourth" 
         reminderNo = i                            
         reminderDate = myReminders(i).date
         m = daysRemaining(reminderDate)
         s1 = nEvents(myReminders(i).nEvent)                 
         MID$(s1, 1) = UCASE$(LEFT$(s1, 1))                        
         s2 = myReminders(i).descr: s4 = ""
         IF myReminders(i).time THEN
            IF myReminders(i).nEvent < 3 THEN
               s = STR$(reminderDate)
               n = VAL(LEFT$(s, 5)) - myReminders(i).time
               k = n MOD 10: IF n > 3 AND n < 21 THEN k = 0      
               SELECT CASE k
               CASE 1                                           
                  s = "st "
               CASE 2
                  s = "nd "
               CASE 3
                  s = "rd "
               CASE ELSE                                                                     
                  s = "th "
               END SELECT                   
               s1 = TRIM$(STR$(n)) + s + s1
            ELSE
               s4 = "Time: "
               IF myReminders(i).nEvent = 4 THEN s4 = "Appointment time: " 
               IF myReminders(i).nEvent = 5 THEN s4 = "Meeting time: "
               n = myReminders(i).time 
               IF n >= 1200 THEN s = " pm" ELSE s = " am"
               IF n >= 1300 THEN n = n - 1200                                     
               s4 = s4 + STR$(n\100) + ":" + RIGHT$(STR$(n), 2) + s
            END IF
         END IF
         s = TRIM$(STR$(reminderDate))
         yr = VAL(LEFT$(s, 4)): mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2))
         n = dayOfWeek(mo, day, yr)
         IF myReminders(i).freq = 5 THEN 'same weekday
            nth = day \ 7 + SGN(day MOD 7)
            s3 = PARSE$(weekNo, " ", nth)
            s3 = s3 + " " + PARSE$(daysOfWeek, " ", n + 1)                          
         ELSE 'same day of the month
            s3 = PARSE$(daysOfWeek, " ", n + 1)
            s3 = s3 + ", " + PARSE$(months, " ", mo) + STR$(day)
         END IF                                                                                 
         IF m THEN                                                     
            s3 = s3 + "         ..." + TRIM$(STR$(m)) + " more days"                   
         ELSE
            s3 = s3 + "         ...This is the day!"
         END IF                                                             

         SetWindowPos CBHNDL, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE
         bkgdColor=RGB(192, 255, 255)
         hBrush = CreateSolidBrush(bkgdColor)
      CASE %WM_CTLCOLORDLG
         FUNCTION = hBrush
      CASE %WM_PAINT
         hDC = GetDC(CB.HNDL)
         '----------------------------------------
         SetTextColor hdc,RGB(200,0,0)
         SetBkColor hdc, bkgdColor
         showRemText hDC, s1, 15, 16, 20
         '----------------------------------------
         SetTextColor hdc,%BLACK  'RGB(0,0,0)
         SetBkColor hdc, bkgdColor
         showRemText hDC, s2, 15, 49, 15
         '----------------------------------------
         SetTextColor hdc,%BLACK  'RGB(0,0,0)
         SetBkColor hdc, bkgdColor
         showRemText hDC, s3, 15, 81, 12
         '----------------------------------------
         SetTextColor hdc,%BLACK  'RGB(0,0,0)
         SetBkColor hdc, bkgdColor
         showRemText hDC, s4, 38, 101, 12           
         ReleaseDC CBHNDL, hDC
      CASE %WM_COMMAND
         IF CBCTL = %IDOK THEN
            DIALOG END CB.HNDL
         ELSEIF CBCTL = %ID_Acknowledge THEN
            'keep as archive and delete it in updateReminver
            incr numArchives: remindersArch(numArchives) = myReminders(i) 
            updateReminder i
            DIALOG END CB.HNDL             
         END IF
      CASE %WM_DESTROY
         DeleteObject hBrush                           
      CASE %WM_SYSCOMMAND
         IF CBCTL = %SC_CLOSE THEN
            exitRemind = 1: DIALOG END CB.HNDL              
         END IF
   END SELECT
END FUNCTION                                              

FUNCTION daysRemaining(dateOfReminder AS LONG) AS LONG
   LOCAL mo AS LONG, day AS LONG, yr AS LONG
   LOCAL m AS LONG, d AS LONG, y AS LONG
   LOCAL s AS STRING, n AS LONG
   s = TRIM$(STR$(dateOfReminder))
   yr = VAL(LEFT$(s, 4))
   mo = VAL(MID$(s, 5, 2))
   day = VAL(MID$(s, 7, 2))
   m = VAL(PARSE$(DATE$, "-", 1))
   d = VAL(PARSE$(DATE$, "-", 2))
   y = VAL(PARSE$(DATE$, "-", 3))
   n = day - d
   WHILE mo <> m OR yr > y
       DECR mo
       IF mo < 1 THEN mo = 12: DECR yr
       n = n + daysInMonth(mo, yr)
   WEND
   function = n                                           
END FUNCTION

SUB showRemText(BYVAL h AS LONG, s AS STRING, x AS DOUBLE, y AS DOUBLE, fontSize AS LONG)
   LOCAL hFont, hOrigFont AS LONG
   local fontType AS STRING
   LOCAL sz AS ASCIIZ * 255
   sz = s                                                      
   fontType = "Times New Roman"
   hFont = makeFont(hdc, fontType, fontSize)
   hOrigFont = SelectObject (BYVAL h, BYVAL hFont)
   IF LEN(s) THEN TextOut BYVAL h, x, y, sz, LEN(sz)
   DeleteObject SelectObject(BYVAL h, BYVAL hOrigFont)
END SUB

FUNCTION MakeFont(hdc AS LONG, sFont AS STRING, BYVAL pointSize AS LONG) AS LONG
  LOCAL CyPixels AS LONG
  CyPixels  = GetDeviceCaps(hDC, %LOGPIXELSY)
  PointSize = (PointSize * CyPixels) \ 72
  FUNCTION = CreateFont(0 - PointSize, 0, 0, 0, %FW_NORMAL, 0, 0, 0, _
            %ANSI_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
            %DEFAULT_QUALITY, %FF_DONTCARE, BYCOPY sFont)
END FUNCTION                                                               

SUB updateReminder(j AS LONG)
   local i, k, m, n, n0, ith, mo, day, yr, today, adv, valToday as long
   local s as string
   local remind, lastReminder as reminderType
   s = TRIM$(STR$(myReminders(j).Date))
   yr = VAL(LEFT$(s, 4)): mo = VAL(MID$(s, 5, 2)): day = VAL(RIGHT$(s, 2))
   today = VAL(RIGHT$(DATE$, 4) + LEFT$(DATE$, 2) + MID$(DATE$, 4, 2))               
   k = myReminders(j).Freq
   IF k = 1 THEN 'update one time only                                                  
      myReminders(j).date = -abs(myReminders(j).date) 'signal deletion
      exit sub 
   elseIF k = 2 THEN 'update to next year                                                    
      INCR yr
   ELSEIF k = 3 THEN 'update to future month, same date
      n = myReminders(j).period
      s = trim$(str$(myReminders(j).date))
      yr = val(left$(s, 4)): mo = val(mid$(s, 5, 2)): day = val(right$(s, 2))        
      do
         mo = mo + n: IF mo > 12 THEN mo = n - 1: INCR yr
      loop until newDate(yr, mo, day) > valToday                                           
      m = daysInMonth(mo, yr): if day > m then day = m
   elseif k = 4 then 'update to future week, same day                                     
      n = myReminders(j).period
      s = trim$(str$(myReminders(j).date))
      yr = val(left$(s, 4)): mo = val(mid$(s, 5, 2)): day = val(right$(s, 2))        
      do                               
         for i = 1 to n
            day = day + 7: m = daysInMonth(mo, yr)          
            if day > m then                                                                     
               incr mo: day = day - m
               if mo > 12 then incr yr: mo = 1                    
            end if                                                            
         next i  
      loop until newDate(yr, mo, day) > valToday     
   ELSEIF k = 5 THEN 'update to same weekday of future month                            
      n = myReminders(j).period
      s = trim$(str$(myReminders(j).date))
      yr = val(left$(s, 4)): mo = val(mid$(s, 5, 2)): day = val(right$(s, 2))        
      do 
         i = dayOfWeek(mo, yr, day)                  
         ith = day \ 7 + SGN(day MOD 7)
         mo = mo + n: IF mo > 12 THEN mo = 1: INCR yr                            
         m = dayOfWeek(mo, yr, 1) '1st day of the month
         day = i - m + 1 + (ith - 1) * 7
         IF i < m THEN day = day + 7                                   
      loop until newDate(yr, mo, day) > valToday                                            
   END IF
   myReminders(j).date = 10000 * yr + 100 * mo + day

   'now insert the reminder and delete the original ----------------------------- 
   remind = myReminders(j)
   remind.date = 10000 * yr + 100 * mo + day
   k = remind.date
   n = 0                                                          
   FOR i = 1 TO numReminders 'find insert position
      IF k < myReminders(i).date THEN n = i: EXIT FOR
   NEXT i
   if numReminders and n > 0 then                                            
      lastReminder = myReminders(numReminders)
      array insert myReminders(n), remind 'last reminder is lost here      
      incr numReminders: myReminders(numReminders) = lastReminder
   else                                                                       
      incr numReminders: myReminders(numReminders) = remind                 
   end if
   myReminders(j).date = -abs(myReminders(j).date)  'signal deletion
END SUB                                  

FUNCTION newDate(yr AS LONG, mo AS LONG, day AS LONG) AS LONG
   FUNCTION = yr * 10000 + mo * 100 + day
END FUNCTION

FUNCTION daysInMonth(mo AS LONG, yr AS LONG) AS LONG
   LOCAL days AS LONG
   IF mo < 8 THEN
      days = 30 + mo MOD 2
   ELSE
      days = 30 + (mo + 1) MOD 2
   END IF
   IF mo = 2 THEN days = 28
   IF (yr MOD 4) = 0 AND yr <> 1900 THEN   'leap yr
      IF mo = 2 THEN INCR days
   END IF
   daysInMonth = days
END FUNCTION

FUNCTION dayOfWeek(mo AS LONG, day AS LONG, yr AS LONG) AS LONG
   'Sun=0, Mon=1, Tue=2,... Sat=6                                    
   LOCAL n AS LONG
   n = yr - 1899 + (yr - 1901) \ 4
   IF mo < 8 THEN
      n = n + 30 * (mo - 1) + mo \ 2
   ELSE
      n = n + 30 * (mo - 1) + (mo + 1) \ 2
   END IF
   IF mo > 2 THEN n = n - 2
   IF (yr MOD 4) = 0 AND yr <> 1900 THEN   'leap yr
      IF mo > 2 THEN INCR n
   END IF                                                                     
   FUNCTION = (n + day -1) MOD 7
END FUNCTION

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
'===================================================================================================
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz                       
END FUNCTION
                                  